<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Monitor;
use App\Models\Ratings;
use App\Models\Servey;
use App\Models\Questions;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;
use Illuminate\Support\Facades\Config;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\ExportRatings;

class RatingController extends Controller
{
    protected static $title = 'Ratings';

     // View data for
     protected static $view_data_for = [
        '1' => 'Today',
        '2' => 'Yesterday',
        '3' => 'Last Week',
        '4' => 'Last Month',
        //'5' => 'Customise'
    ]; 

    public function listing()
    {
        $params = \Request::query();

        $monitor_id=$from_date=$to_date='';

        $is_submit=0;
        if(isset($params['submit']))
        {
            $is_submit=1;
        }

        if(isset($params['monitor_id']) && !empty($params['monitor_id']))
        {
            $monitor_id = $params['monitor_id'];
        }
        if(isset($params['from_date']) && !empty($params['from_date']))
        {
            $from_date = date('Y-m-d',strtotime($params['from_date']));
        }else{
            $from_date = date('Y-m-d',strtotime('-7 days')); 
        }
        if(isset($params['to_date']) && !empty($params['to_date']))
        {
            $to_date = date('Y-m-d',strtotime($params['to_date']));
        }else{
            $to_date = date('Y-m-d');
        }

        $company_id = CID();

        $ratings=array();
        if (Schema::connection('mysql2')->hasTable('ratings')) {
            
            //$monitors->appends(['site_id' => $params['site_id']]);
            
            $ratings = with(new Ratings)->list($monitor_id,$from_date,$to_date); 
            $ratings->appends(['monitor_id' => $monitor_id,'from_date' => $from_date,'to_date'=>$to_date]);
            //echo '<pre>';print_r($ratings);echo '</pre>';
            // $ratings = Ratings::
            // where(
            //     function($query){
            //         if(!empty($from_date) || !empty($to_date)){
            //             $query->whereDate('created_at','>=',$from_date)->whereDate('created_at','<=',$to_date);
            //         }
            //     }
            // )
            // ->with('servey')->select('id','site_id','monitor_id','servey_id','positive','negative','nuetral')
            // ->paginate(Config::get('constants.page_limit'));
        }
        $monitors=array();
        //$GetMonitors = Monitor::select('monitor_key','id','monitor_number','inbuild_location','build_location')->get()->toArray();
        $site_ids = getSites()['site_ids'];
        $GetMonitors = getMonitors($company_id,$site_ids)['monitors'];
        if(!empty($GetMonitors))
        {
            $final_monitors=array();
            foreach($GetMonitors as $m){
                $monitors[$m['id']]=$m['monitor_key'].' - '.$m['inbuild_location'].' '.$m['build_location'];
                $final_monitors=$monitors;
            }
        }
        return view('admin.ratings.index',['title'=>static::$title,'ratings'=>$ratings,'monitors'=>$monitors,'params'=>$params,'from_date'=>$from_date,'to_date'=>$to_date,'is_submit'=>$is_submit]);
    }
    function show($id)
    {
        $rating='';
        if (Schema::connection('mysql2')->hasTable('ratings')) {
            $rating = Ratings::with('customer_details')->find($id);
        }
        if(!empty($rating))
        {
            $servey_response = json_decode($rating->servey_response,true,JSON_UNESCAPED_SLASHES);
            //echo '<pre>';print_r(json_decode($rating->servey_response));echo '</pre>';exit;
            $servey_data=array();
            $i=0;
            foreach($servey_response as $r)
            {
                $question = \App\Models\Questions::withTrashed()->where('id',$r['question_id'])->get()->first();
               
                $servey_data['question_data'][$i]['rating']=$r['rating'];
                $servey_data['question_data'][$i]['question_id']=$r['question_id'];
                $servey_data['question_data'][$i]['question']=$question['question'];
                $servey_data['question_data'][$i]['icon_type']=$question['icon_type'];
                $servey_data['question_data'][$i]['question_type']=$r['question_type'];
                $servey_data['question_data'][$i]['feedback_question_values']=$r['feedback_question_values'];
                $servey_data['question_data'][$i]['options_value']=$r['options_value'];
                $servey_data['question_data'][$i]['sub_questions']= isset($r['sub_questions']) ? $r['sub_questions'] : [];

                $i++;
            }
            $monitor = Monitor::where('id',$rating->monitor_id)->first();
            //echo '<pre>';print_r($servey_data);echo '</pre>';exit;
        }
        
        
        return view('admin.ratings.show',['title'=>static::$title,'rating'=>$rating,'monitor'=>$monitor,'servey_data'=>$servey_data]);
    }

    function question_report()
    {
        $company_id = CID();

        $data=[];
        //// take get params ///////
        $params = \Request::query();

        $monitor_id=$question_id=$from_date=$to_date='';
        if(isset($params['monitor_id']) && !empty($params['monitor_id']))
        {
            $monitor_id = $params['monitor_id'];
        }

        if(isset($params['question_id']) && !empty($params['question_id']))
        {
            $question_id = $params['question_id'];
        }

        if(isset($params['from_date']) && !empty($params['from_date']))
        {
            $from_date = date('Y-m-d',strtotime($params['from_date']));
        }
        if(isset($params['to_date']) && !empty($params['to_date']))
        {
            $to_date = date('Y-m-d',strtotime($params['to_date']));
        }

        if(isset($params['view_data_for']) && !empty($params['view_data_for']))
        {
            $view_data_for = $params['view_data_for'];
            if($view_data_for==1)
            {
                $from_date=$to_date=date('Y-m-d');
            }else if($view_data_for==2){
                $from_date = date('Y-m-d',strtotime("-1 days"));
                $to_date = date('Y-m-d',strtotime("-1 days"));;
            }else if($view_data_for==3){
                $previous_week = strtotime("-1 week +1 day");
                $from_date = date('Y-m-d',strtotime("last sunday midnight",$previous_week));
                $to_date = date('Y-m-d',strtotime("next saturday",strtotime("last sunday midnight",$previous_week)));
            }else if($view_data_for==4){
                $from_date = date('Y-m-d', strtotime('first day of last month'));
                $to_date =date('Y-m-d', strtotime('last day of last month'));
            }
        }

        $monitor_ids=array();
        $GetMonitors = Monitor::select('monitor_key','id','monitor_number','inbuild_location','build_location')->where('company_id',$company_id)->get()->toArray();
        if(!empty($GetMonitors))
        {
            $final_monitors=array();
            foreach($GetMonitors as $m){
                $monitors[$m['id']]=$m['monitor_key'].' - '.$m['inbuild_location'].' '.$m['build_location'];
                $final_monitors=$monitors;
                $monitor_ids[] = $m['id'];
            }
        }
        
        ///// get servey ids /////
        $monitors = !empty($monitor_id) ? array($monitor_id) : $monitor_ids;
        $monitor_servey_ids=[];
        if(!empty($monitors))
        {
            $monitor_servey_ids = Monitor::select('servey_id')->whereIn('id',$monitors)->get()->toArray();
        }

        $questions=$quesionids=array();
        if(!empty($monitor_servey_ids))
        {
            $questions = Questions::select('id','question')->whereIn('servey_id',$monitor_servey_ids)->pluck('question', 'id')->toArray();
            if(!empty($questions))
            {
                foreach($questions as $k=>$q)
                {
                    $quesionids[] = $k;
                }
            }
        }

        $question_ids = !empty($question_id) ? array($question_id) : $quesionids;
        
        if (Schema::connection('mysql2')->hasTable('ratings')) {
                
            if(!empty($question_ids))
            {
                $data['ratings'] = with(new Ratings)->question_report_rating_calc($question_ids,$from_date,$to_date);
            
                if (Schema::connection('mysql2')->hasTable('hourly_question_ratings')) {
                    ////// Feedback Graph Data ///////
                    $data['jsonTable'] = question_hourly_graph_data($question_ids,$from_date,$to_date)['jsonTable'];
                }
            }
        }
        //echo '<pre>';print_r($data);echo '</pre>';
        return view('admin.ratings.question-report',['title'=>'Question Report','data'=>$data,'questions'=>$questions,'monitors'=>$final_monitors,'view_data_for'=>static::$view_data_for,'params'=>$params]);
    }

    function export_ratings($monitor_id=0,$from_date='',$to_date='')
    {
        // $params = \Request::query();

        // $monitor_id=$from_date=$to_date='';
        // if(isset($params['monitor_id']) && !empty($params['monitor_id']))
        // {
        //     $monitor_id = $params['monitor_id'];
        // }
        // if(isset($params['from_date']) && !empty($params['from_date']))
        // {
        //     $from_date = date('Y-m-d',strtotime($params['from_date']));
        // }else{
        //     $from_date = date('Y-m-d',strtotime('-7 days')); 
        // }
        // if(isset($params['to_date']) && !empty($params['to_date']))
        // {
        //     $to_date = date('Y-m-d',strtotime($params['to_date']));
        // }else{
        //     $to_date = date('Y-m-d');
        // }

        $company_id = CID();

        $ratings=array();

        if (Schema::connection('mysql2')->hasTable('ratings')) {
            $ratings = with(new Ratings)->export($monitor_id,$from_date,$to_date); 
        }
       
        //echo '<pre>';print_r($ratings->toArray());echo '</pre>';exit;
        return Excel::download(new ExportRatings($monitor_id,$from_date,$to_date), 'ratings.xlsx');
    }
}

?>