<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Str; 
use App\Models\Token;
use App\Models\User;
use Config;

class ApiAuth
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure(\Illuminate\Http\Request): (\Illuminate\Http\Response|\Illuminate\Http\RedirectResponse)  $next
     * @return \Illuminate\Http\Response|\Illuminate\Http\RedirectResponse
    */
    public function handle(Request $request, Closure $next)
    {
        $header = $request->header('Authorization', '');   
        if (Str::startsWith($header, 'Bearer ')) {
            $token  = Str::substr($header, 7);
            $validate_token = Token::select('company_id')->where('token',$token)->first();
            if($validate_token)
            {
                //echo $validate_token['company_id'];exit;
                $db_name = User::select('db_name')->where('id',$validate_token['company_id'])->first()->db_name;
                Config::set('database.connections.mysql2.database', $db_name);
            }else{
                return error((object)null,'Unauthorized.',401);
            }
        }else{
            return error((object)null,'Unauthorized.',401);
        }
        
        return $next($request);
    }
}
