<?php

namespace App\Http\Requests\Admin;

use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Illuminate\Foundation\Http\FormRequest;

class ServeyTemplateRequest extends FormRequest
{

    public function authorize()
    {
        return true;
    }

    public function rules()
    {
        $rules =  [
            'question' => 'required',
            //'description' => 'required',
            //'question_type' => 'required',
            'image_type' => 'required_if:question_type,1,2',
            //'option1'=> 'required_if:question_type,5',
            'items' => 'sometimes|nullable|required_if:question_type,5|array',
            'items.*.option' => 'required_if:question_type,5|required_with:items',
            'items.*.response_tone' => 'required_if:question_type,5|required_with:items',
            //'option1' => 'required_if:question_type,3|image|mimes:jpg,jpeg,png,gif,svg',
        ];
        // if (\Route::current()->getName() == 'servey.store')
        // {
        // }
        return $rules;
    }

    public function messages()
    {
        return [
        'items.required_if' => 'This question contains atleast one option.',
        'image_type.required_if' => 'This question contains atleast one icon selected.'
        ];
    }
}


?>