<?php

namespace App\Http\Requests\Admin;

use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Illuminate\Foundation\Http\FormRequest;

class SiteUsersRequest extends FormRequest
{
    //use PasswordValidationRules;

    public function authorize()
    {
        return true;
    }

    public function rules()
    {

        Validator::extend('without_spaces', function($attr, $value){
            return preg_match('/^\S*$/u', $value);
        });

        $rules =  [
            'site_id' => 'required',
            'name' => 'required|max:355',
            'contact_no'=>'sometimes|nullable|digits_between:10,12',
            'user_group'=>'required|in:site_manager,cleaning,maintenance,data_manager,supervising'
        ];

        if (\Route::current()->getName() == 'site_users.store')
        {
            $rules['email'] = 'required|email|max:255|unique:users,email';
            $rules['password'] = 'required|min:8';
            $rules['username'] = 'required|min:6|regex:/^\S*$/u|alpha_dash|unique:users';
        }

        return $rules;
    }
}


?>