<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Database\Eloquent\SoftDeletes;


class FeedbackQuestion extends Model
{
    use HasFactory;
    use SoftDeletes;

    public $connection = 'mysql2';

   
    /**
     * The table associated with the model.
     *
     * @var string
    */ 
    protected $table = 'feedback_questions';

    /**
     * set primary key of table
     *
     * @var integer
     */
    //protected $primaryKey = 'id';

    /**
     * Indicates if the model should be timestamped.
     *
     * @var bool
     */
    public $timestamps = true;

    /**
     * fillable column name goes here
     *
     * @var array
     */
    protected $fillable = [
        'id',
        'question',
        'question_type',
        'issue_type',
        'active',
        'created_by',
        'updated_by',
        'deleted_by'
    ];


    public function feedback_question(){
        return $this->hasMany('\App\Models\TemplateFeedbackQuestions');
    }
}
