<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
//use Illuminate\Support\Facades\Config;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Eloquent\SoftDeletes;


class SiteUser extends Model
{
    use HasFactory;
    use SoftDeletes;

    public $connection = 'mysql2';

   
    /**
     * The table associated with the model.
     *
     * @var string
    */ 
    protected $table = 'site_users';

    /**
     * set primary key of table
     *
     * @var integer
     */
    //protected $primaryKey = 'id';

    /**
     * Indicates if the model should be timestamped.
     *
     * @var bool
     */
    public $timestamps = true;

    /**
     * fillable column name goes here
     *
     * @var array
     */
    protected $fillable = [
        'id',
        'site_id',
        'user_id',
        'active',
        'created_by',
        'updated_by',
        'deleted_by'
    ];

    public function sites()
	{
		return $this->hasMany('\App\Models\Site', 'id','site_id');
    }

    public function users()
	{
		return $this->hasMany('\App\Models\User', 'id','user_id');
    }
}
