@extends('layouts.admin.master')
@section('content')
<div class="container-xxl flex-grow-1 container-p-y">
    @include('common.messages')
    @include('common.errors')
    <!-- Hoverable Table rows -->
    <div class="card">
        <div class="row">
            <div class="col-md-9">                                    
                <h5 class="card-header">Listing</h5>            
            </div>
            <div class="col-md-3" style="margin-top:20px;">                                    
                <a href="{{ route('feedback_questions.create') }}" class="btn btn-success btn-large pull-right">Add Option</a>
            </div>
        </div>
        <div class="table-responsive text-nowrap">
            <table class="table table-hover">
            <thead>
                <tr>
                    <th>Option Type</th>
                    <th>Issue Type</th>
                    <th>Option</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody class="table-border-bottom-0">
                @if(!empty($feedback_questions))
                @foreach($feedback_questions as $k=>$c)
                <tr>
                    <td>{{ $question_types[$c['question_type']] }}</td>
                    <td>{{ $issue_types[$c['issue_type']] }}</td>
                    <td>{{ $c['question'] }}</td>
                    <td>
                        <div class="dropdown">
                        <button type="button" class="btn p-0 dropdown-toggle hide-arrow" data-bs-toggle="dropdown">
                            <i class="bx bx-dots-vertical-rounded"></i>
                        </button>
                        <div class="dropdown-menu">
                            {{-- <a class="dropdown-item" href="{{ route('feedback_questions.edit',$c['id']) }}"
                            ><i class="bx bx-edit-alt me-1"></i> Edit</a
                            > --}}
                            {!! Form::open(['url' => route('feedback_questions.destroy', $c['id']), 'method' => 'DELETE']) !!}
                            <button class="dropdown-item"
                            ><i class="bx bx-trash me-1"></i> Delete</button
                            >
                            {!! Form::close(); !!}
                        </div>
                        </div>
                    </td>
                </tr>
                @endforeach
                @endif
            </tbody>
            </table>
        </div>
        <div class="pull-right">
            {{ $feedback_questions->links() }}
        </div>
    </div>
    <!--/ Hoverable Table rows -->
</div>
@endsection