<?php

namespace App\Exports;

use App\Models\Ratings;
use Maatwebsite\Excel\Concerns\FromCollection;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;
use Illuminate\Support\Facades\Config;
use Maatwebsite\Excel\Concerns\WithHeadings;

class ExportRatings implements FromCollection,WithHeadings
{
    private $monitor_id,$from_date,$to_date;

    public function __construct(string $monitor_id,string $from_date,string $to_date) {
        $this->monitor_id = $monitor_id;
        $this->from_date = $from_date;
        $this->to_date = $to_date;
    }
    /**
    * @return \Illuminate\Support\Collection
    */
    public function collection()
    {
        if (Schema::connection('mysql2')->hasTable('ratings')) {
            $ratings = with(new Ratings)->export($this->monitor_id,$this->from_date,$this->to_date); 
        }
        $ratings = $ratings->toArray();
        if(!empty($ratings))
        {
            $final=array();$i=0;
            foreach($ratings as $r)
            {
               
                $monito = \App\Models\Monitor::where('id',$r['monitor_id'])->get()->first();
                $monitor = $monito->inbuild_location.' '.$monito->build_location;

                $servey_response = json_decode($r['servey_response'],true,JSON_UNESCAPED_SLASHES);

                if(!empty($servey_response))
                {
                    //$final=array();
                    foreach($servey_response as $s)
                    {
                        //echo '<pre>';print_r($s);echo '</pre>';exit;
                        $question = \App\Models\Questions::withTrashed()->where('id',$s['question_id'])->get()->toArray();
                        $ques = !empty($question) ? $question[0] : '';
                        //echo '<pre>';print_r($ques['question']);echo '</pre>';exit;
                        
                        $data['rating_id']=$r['id'];
                        $data['site_name']=$r['site_name'];
                        $data['monitor']=$monitor;
                        $data['question_id']=(!empty($ques)) ? $ques['id'] : '';
                        $data['question']=(!empty($ques)) ? $ques['question'] : '';
                        
                        if($s['question_type']==6) 
                        {
                            $data['rating']= ($s['rating']==1) ? 'Yes' : 'No';
                        }else{
                            $data['rating']=$s['rating'];
                        }
                        $data['rating_text'] = '';
                        if($s['question_type']==1 || $s['question_type']==2 || $s['question_type']==4)
                        {
                            $rating_text='';
                            if(!empty($s['feedback_question_values'])) 
                            {
                                $data['rating_text'] = implode(',',$s['feedback_question_values']);
                            }
                        }elseif($s['question_type']==3){

                            $img='';
                            foreach($s['options_value'] as $o)
                            {
                                $img .= url($o).',';
                            }
                            $data['rating_text'] = $img;
                        }elseif($s['question_type']==9){
                            $rating_text='';
                            // if(!empty($s['sub_questions']))
                            // {
                            //     foreach($s['sub_questions'] as $sub)
                            //     {
                            //         $rating_text .= $sub['sub_question'].':'.$sub['options_value'];
                            //     } 
                            // }
                            $rating_text='';
                            foreach($s['sub_questions'] as $sub)
                            {
                                $rating_text .= $sub['sub_question'] .':'.$sub['options_value'].PHP_EOL;
                            }
                            $data['rating_text'] = $rating_text;
                        }elseif($s['question_type']==5 || $s['question_type']==8){
                            $data['rating_text'] = implode(',',$s['options_value']);
                        }else{
                            $data['rating_text'] = '';
                        }
                        $data['created_at']= date('Y-m-d H:i:s',strtotime($r['created_at']));

                        $final[] = $data;
                    }
                }
                
                // $data['site_name']=$r['site_name'];
                // $data['site_name']=$r['site_name'];
                // $data['site_name']=$r['site_name'];
                // $data['site_name']=$r['site_name'];
                //$final[] = $data;
                $i++;
            }
        }
        //echo '<pre>';print_r($final);echo '</pre>';exit;
        return collect($final);
    }

    public function headings() :array
    {
        return ["Rating ID", "Site Name", "Monitor","Question ID", "Question","Ratings","Rating Text","Created"];
    }
}
