<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Monitor;
use App\Models\Ratings;
use App\Models\Servey;
use App\Models\Site;
use App\Models\Questions;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;


class AjaxController extends Controller
{
    public function get_monitors_and_questions_by_site(Request $request)
    {
        $company_id = CID();
        //print_r($request->all());
        $site_id = $request->site_id;
        $monitor_ids=array();
        if($site_id > 0)
        {
            $GetMonitors = Monitor::select('monitor_key','id','monitor_number','inbuild_location','build_location')->where('company_id',$company_id)->where('site_id',$site_id)->get()->toArray();
        }else{
            $site_ids = getSites()['site_ids'];
            //$GetMonitors = Monitor::select('monitor_key','id','monitor_number','inbuild_location','build_location')->where('company_id',$company_id)->get()->toArray();
            $GetMonitors = getMonitors($company_id,$site_ids)['monitors'];
        }

        if(!empty($GetMonitors))
        {
            $final_monitors=array();
            foreach($GetMonitors as $m){
                $monitor_datas[$m['id']]=$m['monitor_key'].' - '.$m['inbuild_location'].' '.$m['build_location'];
                $final_monitors=$monitor_datas;
                $monitor_ids[] = $m['id'];
            }
        }

        ///// get servey ids /////
        $monitor_servey_ids=[];
        if(!empty($monitor_ids))
        {
            $monitor_servey_ids = Monitor::select('servey_id')->whereIn('id',$monitor_ids)->get()->toArray();
        }

        $questions=$quesionids=array();
        if(!empty($monitor_servey_ids))
        {
            $questions = Questions::select('id','question')->whereIn('servey_id',$monitor_servey_ids)->where('question_type','<>',7)->pluck('question', 'id')->toArray();
        }

        return response()->json(['monitors' => $monitor_datas,'questions'=>$questions]);
    }

    function get_questions_by_monitor(Request $request)
    {
        $company_id = CID();
        $monitor_id = $request->monitor_id;
        
        $monitor_ids=[];
        if($monitor_id==0)
        {
            $GetMonitors = Monitor::select('monitor_key','id','monitor_number','inbuild_location','build_location')->where('company_id',$company_id)->get()->toArray();
            if(!empty($GetMonitors))
            {
                foreach($GetMonitors as $m){
                    $monitor_ids[] = $m['id'];
                }
            }
        }
       
        $monitors = ($monitor_id > 0) ? array($monitor_id) : $monitor_ids;
        $monitor_servey_ids=[];
        if(!empty($monitors))
        {
            $monitor_servey_ids = Monitor::select('servey_id')->whereIn('id',$monitors)->get()->toArray();
        }
        
        $questions=$quesionids=array();
        if(!empty($monitor_servey_ids))
        {
            $questions = Questions::select('id','question')->whereIn('servey_id',$monitor_servey_ids)->where('question_type','<>',7)->pluck('question', 'id')->toArray();
        }

        return response()->json(['questions'=>$questions]);
    }

    function get_customize_date(Request $request)
    {
        $view_data_for = $request->view_data_for;
        if($view_data_for==1)
        {
            $from_date=$to_date=date('Y-m-d');
        }else if($view_data_for==2){
            $from_date = date('Y-m-d',strtotime("-1 days"));
            $to_date = date('Y-m-d',strtotime("-1 days"));;
        }else if($view_data_for==3){
            $previous_week = strtotime("-1 week +1 day");
            $from_date = date('Y-m-d',strtotime("last sunday midnight",$previous_week));
            $to_date = date('Y-m-d',strtotime("next saturday",strtotime("last sunday midnight",$previous_week)));
        }else if($view_data_for==4){
            $from_date = date('Y-m-d', strtotime('first day of last month'));
            $to_date =date('Y-m-d', strtotime('last day of last month'));
        }else{
            $from_date = $to_date='';
        }

        return response()->json(['from_date'=>$from_date,'to_date'=>$to_date]);
    }
}