<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Monitor;
use App\Models\Ratings;
use App\Models\Servey;
use App\Models\Site;
use App\Models\Questions;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;


class DashboardController extends Controller
{
    protected static $title = 'Dashboard';

    // View data for
    protected static $view_data_for = [
        '1' => 'Today',
        '2' => 'Yesterday',
        '3' => 'Last Week',
        '4' => 'Last Month',
        '5' => 'Customise'
    ]; 

    public function index()
    {
        if(Auth::user()->role==1)
        {
            return view('superadmin_dashboard',['title'=>static::$title]);
        }
        else 
        {
            $company_id = CID();

            //// take get params ///////
            $params = \Request::query();

            $monitor_id=$site_id=$question_id=$from_date=$to_date='';

            if(isset($params['site_id']) && !empty($params['site_id']))
            {
                $site_id = $params['site_id'];
            }

            if(isset($params['monitor_id']) && !empty($params['monitor_id']))
            {
                $monitor_id = $params['monitor_id'];
            }

            if(isset($params['question_id']) && !empty($params['question_id']))
            {
                $question_id = $params['question_id'];
            }

            if(isset($params['from_date']) && !empty($params['from_date']))
            {
                $from_date = date('Y-m-d',strtotime($params['from_date']));
            }
            if(isset($params['to_date']) && !empty($params['to_date']))
            {
                $to_date = date('Y-m-d',strtotime($params['to_date']));
            }

            if(isset($params['view_data_for']) && !empty($params['view_data_for']))
            {
                $view_data_for = $params['view_data_for'];
                if($view_data_for==1)
                {
                    $from_date=$to_date=date('Y-m-d');
                }else if($view_data_for==2){
                    $from_date = date('Y-m-d',strtotime("-1 days"));
                    $to_date = date('Y-m-d',strtotime("-1 days"));;
                }else if($view_data_for==3){
                    $previous_week = strtotime("-1 week +1 day");
                    $from_date = date('Y-m-d',strtotime("last sunday midnight",$previous_week));
                    $to_date = date('Y-m-d',strtotime("next saturday",strtotime("last sunday midnight",$previous_week)));
                }else if($view_data_for==4){
                    $from_date = date('Y-m-d', strtotime('first day of last month'));
                    $to_date =date('Y-m-d', strtotime('last day of last month'));
                }
            }else{
                $from_date = '2022-07-01';
                $to_date =date('Y-m-d');
            }
            
            // try { 
            //     $sites = Site::select('id','name')->where('company_id',$company_id)->pluck('name', 'id')->toArray();
            // }catch(\Illuminate\Database\QueryException $ex){ 
            //     //return redirect()->with('error', $ex->getMessage()); 
            //     //abort(404);
            // }
            $sites = Site::select('id','name')->where('company_id',$company_id)->pluck('name', 'id')->toArray();
            
            $monitor_ids=array();
            if(!empty($site_id))
            {
                $GetMonitors = Monitor::select('monitor_key','id','monitor_number','inbuild_location','build_location')->where('company_id',$company_id)->where('site_id',$site_id)->get()->toArray();
            }else{
                $GetMonitors = Monitor::select('monitor_key','id','monitor_number','inbuild_location','build_location')->where('company_id',$company_id)->get()->toArray();
            }
            $final_monitors=array();
            if(!empty($GetMonitors))
            {
                $final_monitors=array();
                foreach($GetMonitors as $m){
                    $monitors[$m['id']]=$m['monitor_key'].' - '.$m['inbuild_location'].' '.$m['build_location'];
                    $final_monitors=$monitors;
                    $monitor_ids[] = $m['id'];
                }
            }

            ///// get servey ids /////
            $monitors = !empty($monitor_id) ? array($monitor_id) : $monitor_ids;
            $monitor_servey_ids=[];
            if(!empty($monitors))
            {
                $monitor_servey_ids = Monitor::select('servey_id')->whereIn('id',$monitors)->get()->toArray();
            }

            $questions=$quesionids=array();
            if(!empty($monitor_servey_ids))
            {
                $questions = Questions::select('id','question')->whereIn('servey_id',$monitor_servey_ids)->where('question_type','<>',7)->pluck('question', 'id')->toArray();
                if(!empty($questions))
                {
                    foreach($questions as $k=>$q)
                    {
                        $quesionids[] = $k;
                    }
                }
            }

            $question_ids = !empty($question_id) ? array($question_id) : $quesionids;
            
            // $data['positive_ratings'] = DB::connection('mysql2')->table('ratings')
            // DB::raw('SUM(positive) as total_positive'))
            // ->sum('positive')->avg('positive_avg');
            
         
           

            if (Schema::connection('mysql2')->hasTable('ratings')) {
                
                $data['is_data'] = 1;

                if(!empty($question_id) &&  (Schema::connection('mysql2')->hasTable('rating_question_details')))
                {
                    $data['ratings'] = with(new Ratings)->question_report_rating_calc($question_ids,$from_date,$to_date);
                    if (Schema::connection('mysql2')->hasTable('hourly_question_ratings')) {
                        ////// Feedback Graph Data ///////
                        $data['jsonTable'] = question_hourly_graph_data($question_ids,$from_date,$to_date)['jsonTable'];
                    }
                }else{
                    $data['ratings'] = with(new Ratings)->rating_calc($monitor_id,$from_date,$to_date); 
                    if (Schema::connection('mysql2')->hasTable('hourly_ratings')) {
                        ////// Feedback Graph Data ///////
                        $data['jsonTable'] = hourly_graph_data($monitor_id,$from_date,$to_date)['jsonTable'];
                        
                        //$data['heat_map_data'] = hourly_graph_data($monitor_id,$from_date,$to_date)['heat_map_data'];
                        
                    }
                }

                //echo $from_date.':'.$to_date;
                $from_strtime = strtotime($from_date);
                $to_strtime = strtotime($to_date);
                $date_diff =  $to_strtime - $from_strtime;
                $date_diff_in_days =  round($date_diff / (60 * 60 * 24));
                //echo $date_diff_in_days;
                $data['heat_map_data'] = '';
                $data['is_heat_map_show'] = 0;
                // if($date_diff_in_days >= 7)
                // {
                    $data['is_heat_map_show'] = 1;
                    $startDate = !empty($from_date) ? $from_date : '2022-07-01';

                    $endDate = !empty($to_date) ? $to_date : date('Y-m-d');
                    $endDate = strtotime($endDate);
                    
                    $day_params=[];
                    $mondays=$tuesdays=$wednesdays=$thursdays=$fridays=$saturdays=$sundays=[];
                    for($m = strtotime('Monday', strtotime($startDate)); $m <= $endDate; $m = strtotime('+1 week', $m))
                    {
                        $mondays[]  = date('Y-m-d', $m);
                        $day_params['mondays'] = $mondays;
                    }
                    for($t = strtotime('Tuesday', strtotime($startDate)); $t <= $endDate; $t = strtotime('+1 week', $t))
                    {
                        $tuesdays[]  = date('Y-m-d', $t);
                        $day_params['tuesdays'] = $tuesdays;
                    } 

                    for($w = strtotime('Wednesday', strtotime($startDate)); $w <= $endDate; $w = strtotime('+1 week', $w))
                    {
                        $wednesdays[]  = date('Y-m-d', $w);
                        $day_params['wednesdays'] = $wednesdays;
                    } 

                    for($th = strtotime('Thursday', strtotime($startDate)); $th <= $endDate; $th = strtotime('+1 week', $th))
                    {
                        $thursdays[]  = date('Y-m-d', $th);
                        $day_params['thursday'] = $thursdays;
                    } 

                    for($fr = strtotime('Friday', strtotime($startDate)); $fr <= $endDate; $fr = strtotime('+1 week', $fr))
                    {
                        $fridays[]  = date('Y-m-d', $fr);
                        $day_params['fridays'] = $fridays;
                    } 

                    for($sat = strtotime('Saturday', strtotime($startDate)); $sat <= $endDate; $sat = strtotime('+1 week', $sat))
                    {
                        $saturdays[]  = date('Y-m-d', $sat);
                        $day_params['saturdays'] = $saturdays;
                    } 

                    for($sun = strtotime('Sunday', strtotime($startDate)); $sun <= $endDate; $sun = strtotime('+1 week', $sun))
                    {
                        $sundays[]  = date('Y-m-d', $sun);
                        $day_params['sundays'] = $sundays;
                    } 

                    //echo '<pre>';print_r($params);echo '</pre>';
                    //$data['heat_map_data'] = with(new Ratings)->monthly_rating_in_per_houlrly_chart_data($monitor_id,$day_params);
                    if(!empty($question_id) &&  (Schema::connection('mysql2')->hasTable('rating_question_details')))
                    {
                        $table='hourly_question_ratings';
                    }else{
                        $table='hourly_ratings';
                    }
                    $data['heat_map_data'] = with(new Ratings)->monthly_rating_in_per_houlrly_chart_data($monitor_id,$day_params,$question_id,$table);
                    $data['top_N_feedbacks'] = with(new Ratings)->top_N_feedbacks($monitor_id,$question_id,$params,3);
                    $data['top_P_feedbacks'] = with(new Ratings)->top_P_feedbacks($monitor_id,$question_id,$params,3);
                    
                    //echo '<pre>';print_r($data['heat_map_data']);echo '</pre>';
                //}
                
                
                //print_r($data['monday_ratings']);

                //$data['top_N_feedbacks'] = with(new Ratings)->top_N_feedbacks($monitor_id,$params,3);
                // $data['ratings'] = DB::connection('mysql2')->table('ratings')->select(DB::raw('SUM(positive) as total_positive') , DB::raw('(AVG(positive_avg)) as positive_avg'), 
                // DB::raw('AVG(positive_per) as positive_per'),
                // DB::raw('SUM(negative) as total_negative') , DB::raw('(AVG(negative_avg)) as negative_avg'),
                // DB::raw('AVG(negative_per) as negative_per'),
                // DB::raw('SUM(nuetral) as total_neutral') , DB::raw('(AVG(neutral_avg)) as neutral_avg'),
                // DB::raw('AVG(neutral_per) as neutral_per')
                // )->first();

                //echo '<pre>';print_r($data);echo '</pre>';
            }
            
          
            //echo '<pre>';print_r($params);echo '</pre>';
            return view('dashboard',['title'=>static::$title,'data'=>$data,'questions'=>$questions,'sites'=>$sites,'monitors'=>$final_monitors,'view_data_for'=>static::$view_data_for,'params'=>$params]);
        
        }

    }
}
