<?php

namespace App\Http\Controllers;

use App\Models\Monitor;
use App\Models\Site;
use App\Models\Servey;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Config;
use Illuminate\Support\Facades\DB;
use App\Http\Requests\Admin\MonitorRequest;
use Illuminate\Support\Facades\Schema;
use App\Http\Controllers\CompanyRoleController;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Artisan;
use Illuminate\Support\Facades\Storage;
use File;



class MonitorController extends CompanyRoleController
{
    protected static $title = 'Monitors';
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    
    public function index()
    {
        $params = \Request::query();

        $company_id = CID();
        $sites = Site::where('active',1)->pluck('name','id')->toArray();
        $monitors=array();
        //if (Schema::connection('mysql2')->hasTable('monitors')) {
            if(isset($params['site_id']) && !empty($params['site_id']))
            {
                $monitors = Monitor::where('active','1')->where('company_id',CID())->where('site_id',$params['site_id'])->get();
                //$monitors->appends(['site_id' => $params['site_id']]);
            }else{
                $monitors = Monitor::where('company_id',CID())->where('active','1')->get();
            }
        //}
        return view('admin.monitors.index',['monitors'=>$monitors,'sites'=>$sites,'params'=>$params,'title'=>static::$title]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $sites = Site::where('active',1)->pluck('name','id')->toArray();
        $servey = Servey::where('active',1)->pluck('name','id')->toArray();
        return view('admin.monitors.create',['sites'=>$sites,'servey'=>$servey,'title'=>static::$title]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(MonitorRequest $request)
    {
        ///// Make unique monitor key - formula : companyID + 1100 + last-monitor-id //////

       $company_id=Auth::user()->id;
        //// get last montor id
        $get_last_monitor_id = Monitor::select('id')->orderBy('id','desc')->first();
        $last_monitor_id = isset($get_last_monitor_id) ? '1100'.intval($get_last_monitor_id->id)+1  : '11001';
        
        $monitor = Monitor::create([
            'company_id'=>CID(),
            'site_id' => $request->site_id,
            'servey_id' => $request->servey_id,
            'monitor_key' => $last_monitor_id,
            'monitor_number' => $request->monitor_number,
            'inbuild_location'=>$request->inbuild_location,
            'build_location'=>$request->build_location,
            'created_by' => Auth::user()->id
        ]);
        if($monitor)
        {
            // //// Save cofiguarations //////
            
            // ////// save date configuaration//////
            // $date_config = \App\Models\MonitorConfig::create([
            //     'monitor_id'=>$monitor->id,
            //     'config_id' => 1,
            //     'date_format' => $request->date_format,
            //     'created_by' => Auth::user()->id
            // ]); 
            
            // ////// save clock configuaration//////
            // $clock_config = \App\Models\MonitorConfig::create([
            //     'monitor_id'=>$monitor->id,
            //     'config_id' => 2,
            //     'clock_format' => $request->clock_format,
            //     'created_by' => Auth::user()->id
            // ]); 
           
            // if(isset($request->dispaly_advertise) && !empty($request->dispaly_advertise))
            // {
            //     /// Upload advertisement /////
            //     $advert_path='';
            //     if($request->file('advertise_img')){
                    
            //         // $path = $request->file('advertise_img');
            //         // //$image = time().'_'.$path->getClientOriginalName();
            //         // $image = time().rand(1,99).'.'.$path->extension();
            //         // $path->move(public_path('images/advertisements'), $image);
            //         // $advertise_path = 'images/advertisements/'.$image;
            //         $image_path = 'images/advertisements';
            //         $advert_image = UploadFile($request->file('advertise_img'),$image_path);

            //         if (file_exists(public_path($advert_image))) {
            //             //// save configuration /////
            //             $advert_config = \App\Models\MonitorConfig::create([
            //                 'monitor_id'=>$monitor->id,
            //                 'config_id' => 3,
            //                 'created_by' => Auth::user()->id
            //             ]); 
            //             //// save advertise /////
            //             $clock_config = \App\Models\MonitorAdvert::create([
            //                 'monitor_id'=>$monitor->id,
            //                 'image' => $advert_image,
            //                 'sort'=>1,
            //                 'created_by' => Auth::user()->id
            //             ]); 
            //         }else{
            //             return redirect()->route('monitors.index')->with('message', 'Monitor created successfully but advertisement not uploaded properly. Please upload advertise again.');
            //         }
            //     } 
            // }
            
            return redirect()->route('monitors.index')->with('message', 'Monitor created successfully.');
        }

        return redirect()->back()
        ->withInput();
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\FeedbackQuestion  $feedback_question
     * @return \Illuminate\Http\Response
     */
    public function show(MonitorRequest $feedback_question)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\FeedbackQuestion  $feedback_question
     * @return \Illuminate\Http\Response
    */
    public function edit($id)
    {
        $sites = Site::where('active',1)->pluck('name','id')->toArray();
        $servey = Servey::where('active',1)->pluck('name','id')->toArray();
        // $monitor_config = \App\Models\MonitorConfig::where('monitor_id',$id)->get()->toArray();
        // //echo '<pre>';print_r($monitor_config);echo '</pre>';
        // $date_key = array_search('1', array_column($monitor_config, 'config_id'));
        // $clock_key = array_search('2', array_column($monitor_config, 'config_id'));
        // $advert_key = array_search('3', array_column($monitor_config, 'config_id'));
        
        // $config['date_format']=$config['clock_format']=$config['advertise']='';
        // $config['is_advert']=0;
        // if($date_key!='')
        // {
        //     $config['date_format']=$monitor_config[$date_key]['date_format'];
        // }
        // if($clock_key!='')
        // {
        //     $config['clock_format']=$monitor_config[$clock_key]['clock_format'];
        // }
        // if($advert_key!='')
        // {
        //     $config['is_advert']=1;
        //     $config['advertise']=\App\Models\MonitorAdvert::select('image')->where('monitor_id',$id)->get()->first();
        // }
        if($id)
        {
            $monitor = Monitor::find($id);
            if($monitor)
            {
                return view('admin.monitors.edit', ['sites'=>$sites,'servey'=>$servey,'monitor' => $monitor,'encode_monitor_id'=>enc_text($id),'title'=>static::$title,'is_edit'=>1]);
            }
        }

        abort(404);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\FeedbackQuestion  $feedback_question
     * @return \Illuminate\Http\Response
     */
    public function update(MonitorRequest $request, $id)
    {
        if($id)
        {
            $post = $request->all();
            $post['updated_by'] = Auth::user()->id;
            $monitor = Monitor::find($id);

            if($post && $monitor)
            {
                if($monitor->update($post))
                {
                    // ////// save date configuaration//////
                    // $date_config = [
                    //     'monitor_id'=>$id,
                    //     'config_id' => 1,
                    //     'date_format' => $request->date_format,
                    //     'updated_by' => Auth::user()->id,
                    //     'updated_at' => date('Y-m-d H:i:s')
                    // ]; 
                    // \App\Models\MonitorConfig::updateOrCreate(
                    //     ['monitor_id' => $monitor->id,'config_id'=>1],
                    //     $date_config
                    // );
                    
                    // ////// save clock configuaration//////
                    // $clock_config = [
                    //     'monitor_id'=>$monitor->id,
                    //     'config_id' => 2,
                    //     'clock_format' => $request->clock_format,
                    //     'updated_by' => Auth::user()->id,
                    //     'updated_at' => date('Y-m-d H:i:s')
                    // ]; 
                    // \App\Models\MonitorConfig::updateOrCreate(
                    //     ['monitor_id' => $monitor->id,'config_id'=>2],
                    //     $clock_config
                    // );
                    // //$monitor_clock_config = \App\Models\MonitorConfig::where('monitor_id',$id)->where('config_id',2)->update($clock_config);

                    // if(isset($request->dispaly_advertise) && !empty($request->dispaly_advertise))
                    // {
                    //     if($request->file('advertise_img'))
                    //     {
                    //         $monitor_image_config = \App\Models\MonitorAdvert::where('monitor_id',$id)->first();
                    //         if($monitor_image_config)
                    //         {
                    //             //// remove image from folder ///////
                    //             $delete_file = DeleteFile($monitor_image_config->image);
                    //             if($delete_file==true)
                    //             {
                    //                 \App\Models\MonitorAdvert::where('monitor_id',$id)->delete();
                    //             }
                    //         }
                    //         /// Upload advertisement /////
                    //         $advert_path='';
                    //         if($request->file('advertise_img')){
                                
                    //             $image_path = 'images/advertisements';
                    //             $advert_image = UploadFile($request->file('advertise_img'),$image_path);
                    //             if (file_exists(public_path($advert_image))) {
                    //                 //// save configuration /////
                    //                 $advert_config = [
                    //                     'monitor_id'=>$id,
                    //                     'config_id' => 3,
                    //                     'created_by' => Auth::user()->id
                    //                 ]; 
                    //                 \App\Models\MonitorConfig::updateOrCreate(
                    //                     ['monitor_id' => $monitor->id,'config_id'=>3],
                    //                     $advert_config
                    //                 );
                                    
                    //                 //// save advertise /////
                    //                 $clock_config = \App\Models\MonitorAdvert::create([
                    //                     'monitor_id'=>$id,
                    //                     'image' => $advert_image,
                    //                     'sort'=>1,
                    //                     'created_by' => Auth::user()->id
                    //                 ]); 
                    //             }else{
                    //                 return redirect()->route('monitors.index')->with('message', 'Monitor created successfully but advertisement not uploaded properly. Please upload advertise again.');
                    //             }
                    //         } 
                    //     }
                    // }else{
                    //     //// Delete advert /////
                    //     \App\Models\MonitorConfig::where('monitor_id',$id)->where('config_id',3)->delete();
                    //     \App\Models\MonitorAdvert::where('monitor_id',$id)->delete();
                    // }

                    return redirect()->route('monitors.index')->with('message', 'Monitor edited successfully.');
                }
            }
            return redirect()->back()->with('error', __('messages.somethingWrong'));
        }

        abort(404);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\FeedbackQuestion  $feedback_question
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $up_data['deleted_by'] = Auth::user()->id;
        Monitor::find($id)->update($up_data);

        Monitor::find($id)->delete();
  
        return redirect()->route('monitors.index')->with('message', 'Monitor deleted successfully.');
    
    }

    public function duplicate($id)
    {
        if($id)
        {
            $monitor = Monitor::find($id);

            if($monitor)
            {
                $company_id=Auth::user()->id;
                //// get last montor id
                $get_last_monitor_id = Monitor::withTrashed()->select('id')->orderBy('id','desc')->first();
                $last_monitor_id = isset($get_last_monitor_id) ? '1100'.intval($get_last_monitor_id->id)+1  : '11001';

                $duplicate_monitor = Monitor::create([
                    'company_id'=>CID(),
                    'site_id' => $monitor->site_id,
                    'servey_id' => $monitor->servey_id,
                    'monitor_key' => $last_monitor_id,
                    'monitor_number' => $monitor->monitor_number,
                    'inbuild_location'=>$monitor->inbuild_location,
                    'build_location'=>$monitor->build_location,
                    'created_by' => Auth::user()->id
                ]);
                if($duplicate_monitor)
                {
                    //// Save cofiguarations //////
                    $configurations = \App\Models\MonitorConfig::where('monitor_id',$id)->get();
                    if(!empty($configurations))
                    {
                        foreach($configurations as $cg)
                        {
                            $config_data = $cg->replicate();
                            $config_data->monitor_id=$duplicate_monitor->id;
                            $config_data->created_by=Auth::user()->id;
                            $config_data->created_at=$config_data->updated_at=date('Y-m-d H:i:s');
                            $save_config = $config_data->save();
                        }
                    }
                    
                    //// Save advertisement //////
                    $advertise =\App\Models\MonitorAdvert::where('monitor_id',$id)->get();
                    if($advertise)
                    {
                        foreach($advertise as $ad)
                        {
                            $advertise_data = $ad->replicate();
                            $advertise_data->monitor_id=$duplicate_monitor->id;
                            $advertise_data->created_by=Auth::user()->id;
                            $advertise_data->created_at=$config_data->updated_at=date('Y-m-d H:i:s');
                            $save_advert = $advertise_data->save();
                        } 
                    }
                    return redirect()->route('monitors.edit',$duplicate_monitor->id)->with('message', 'Monitor duplicated successfully.');
                }
                return redirect()->back()
                ->withInput();
            }
        }
        abort(404);
    }

    function reset_settings($monitor_id)
    {
        $tokens = \App\Models\MonitorDeviceTokens::where('monitor_id', $monitor_id)->orderBy('id','ASC')->get()->toArray();
      
        $token=array();
        if(!empty($tokens))
        {
            foreach($tokens as $t)
            {
                $token[]=$t['token'];
            }
        }
        if(!empty($token))
        {
            $payload = array(
                "registration_ids" => $token,
                "notification"=>array(
                    "title" => 'Feedback247',
                    "body"=> "Reset settings",
                    "icon" => "ic_launcher",
                    "click_action"=>""
                ),
                "data"=>array(
                    "monitor_id" => $monitor_id
                )
            );
            $res = android_push_notification($payload, $token);

            if($res == 1){
               // success code
               return redirect()->back()->with('message', 'Settings reset successfully.');
            }else{
                // fail code
                return redirect()->back()->with('error', __('messages.somethingWrong'));
            } 
        }
    }
}
