<?php

namespace App\Http\Controllers\api;

use App\Models\H360CleaningActivity; 
use Validator;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Str; 
use App\api_helper;
use Config;
use Illuminate\Support\Facades\Schema;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Schema\Blueprint;

class HygieneMonitorCleaningActivityApi extends Controller
{
    public function SaveCleaningActivity(Request $request)
    {
        $request_parameters = array("monitor_no","RFID");
        $token = json_decode(bearerToken($request,$request_parameters));
        if($token->is_error==1)
        {
            return error((object)null,'Missing Parameter '.$token->data,400);
        }

        $date = (isset($request->date) && !empty($request->date)) ? $request->date : date('Y-m-d');
        $time = (isset($request->time) && !empty($request->time)) ? $request->time : date('H:i:s');
        $datetime = $date.' '.$time;

        $cl = H360CleaningActivity::create([
            'monitor_no' => $request->monitor_no,
            'counter' => (isset($request->counter) && !empty($request->counter)) ? $request->counter : 0,
            'date' => $date,
            'time' => $time,
            'RFID'=>$request->RFID,
            'datetime' => $datetime
        ]);

        if($cl)
        {
            $getcl_activity = H360CleaningActivity::select('monitor_no','counter','date','time','RFID')->where('id',$cl->id)->first();
            return success($getcl_activity,'Success',200);
        }else{
            return success([],'Fail',200);
        }
        
        //$data = DB::connection('mysql3')->table('feedbacks')->get()->toArray();
        //print_r($getFeedback);
    }
}