<?php

namespace App\Http\Controllers\api;

use App\Models\H360Footfalls; 
use Validator;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Str; 
use App\api_helper;
use Config;
use Illuminate\Support\Facades\Schema;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Schema\Blueprint;

class HygieneMonitorFootfallApi extends Controller
{
    public function SaveFootfall(Request $request)
    {
        $request_parameters = array("monitor_no");
        $token = json_decode(bearerToken($request,$request_parameters));
        if($token->is_error==1)
        {
            return error((object)null,'Missing Parameter '.$token->data,400);
        }

        $date = (isset($request->date) && !empty($request->date)) ? $request->date : date('Y-m-d');
        $time = (isset($request->time) && !empty($request->time)) ? $request->time : date('H:i:s');
        $datetime = $date.' '.$time;

        $footfall = H360Footfalls::create([
            'monitor_no' => $request->monitor_no,
            'in_footfalls' => (isset($request->in_footfalls) && !empty($request->in_footfalls)) ? $request->in_footfalls : 0,
            'out_footfalls' => (isset($request->out_footfalls) && !empty($request->out_footfalls)) ? $request->out_footfalls : 0,
            'date' => $date,
            'time' => $time,
            'datetime' => $datetime
        ]);

        if($footfall)
        {
            $getfootfall = H360Footfalls::select('monitor_no','in_footfalls','out_footfalls','date','time')->where('id',$footfall->id)->first();
            return success($getfootfall,'Success',200);
        }else{
            return success([],'Fail',200);
        }
        
        //$data = DB::connection('mysql3')->table('feedbacks')->get()->toArray();
        //print_r($getFeedback);
    }
}