<?php

namespace App\Http\Controllers\api;

use App\Models\H360Feedbacks; 
use Validator;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Str; 
use App\api_helper;
use Config;
use Illuminate\Support\Facades\Schema;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Schema\Blueprint;

class HygieneMonitorRatingApi extends Controller
{
    //// Just for Testing purpose //////
    function validateToken(Request $request)
    {
        //echo bearerToken($request)->token;
        //MethodAllow('post',$request->method);
    }
    public function SaveFeedback(Request $request)
    {
        $request_parameters = array("monitor_no","rating");
        $token = json_decode(bearerToken($request,$request_parameters));
        if($token->is_error==1)
        {
            return error((object)null,'Missing Parameter '.$token->data,400);
        }

        $date = (isset($request->date) && !empty($request->date)) ? $request->date : date('Y-m-d');
        $time = (isset($request->time) && !empty($request->time)) ? $request->time : date('H:i:s');
        $datetime = $date.' '.$time;

        $feedback = H360Feedbacks::create([
            'monitor_no' => $request->monitor_no,
            'rating' => $request->rating,
            'date' => $date,
            'time' => $time,
            'datetime' => $datetime
        ]);

        if($feedback)
        {
            $getFeedback = H360Feedbacks::select('monitor_no','rating','date','time')->where('id',$feedback->id)->first();
            return success($getFeedback,'Success',200);
        }else{
            return success([],'Fail',200);
        }
        
        //$data = DB::connection('mysql3')->table('feedbacks')->get()->toArray();
        //print_r($getFeedback);
    }
}