<?php

namespace App\Http\Controllers\api;

use App\Models\Monitor; 
use App\Models\Token;
use App\Models\MonitorDeviceTokens;
use App\Models\User;
use Validator;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Str; 
use App\api_helper;

class MonitorLogin extends Controller
{
    function getData()
    {
        return ["Shivani","Sohan"];
    }

    function login(Request $request)
    {
        $validator = Validator::make($request->all(),[
            'monitor_key' => 'required|string',
        ]);

        if($validator->fails()){
            return error((object)null,$validator->errors(),200);   
        }

        $monitor = Monitor::where('active','1')->where('monitor_key',$request->monitor_key)->first();
        if($monitor)
        {
            $CreateToken = strtotime('YmdHis').Str::random(50);
            $token = Token::create([
                'company_id'=>$monitor->company_id,
                'tokenable_id' => $monitor->id,
                'token' => $CreateToken
            ]);
            
            $data['token']=$CreateToken;
            $data['details']=$monitor;
            
            ///// save monitor token /////
            if(isset($request->device_token) && !empty($request->device_token))
            {
                $check_unique_token = MonitorDeviceTokens::where('monitor_id',$monitor->id)->where('token',$request->device_token)->get()->first();
                if(!empty($check_unique_token)){}else{
                    $device_token = MonitorDeviceTokens::create([
                        'monitor_id'=>$monitor->id,
                        'device_id' => 1, /// 1:android,2:ios
                        'token' => $request->device_token
                    ]);
                }
            }

            return success($data,'Loggedin Successfully.',200);
        }
        return error((object)null,'Monitor not found.',401); 
    }

    function UserLogin(Request $request)
    {
        // Check request type post or not
        $validator = Validator::make($request->all(),[
            'login_key' => 'required|string',
            'company_id' => 'required',
        ]);

        if($validator->fails()){
            return error((object)null,$validator->errors(),200);   
        }
  
        /////   check login key exist in comapny or not ////
        $user= User::where('login_key',$request->login_key)->where('company_id',$request->company_id)->where('role',3)->first();
        
        if($user)
        {
            return success($user, "Success", 200); 
        }else{
            return error((object)null, "Invalid Login Details", 401);
        }
    }
    function logout(Request $request)
    {
        $header = $request->header('Authorization', '');   
        if (Str::startsWith($header, 'Bearer ')) {
            $token  = Str::substr($header, 7);
            $token = Token::where('token',$token)->forceDelete();
            if($token)
            {
                return success((object)null, "Success", 200); 
            }else{
                return error((object)null, "Invalid token", 401);
            }
        }else{
            return error((object)null, "Invalid token", 401);
        }
    }
}
?>