<?php

namespace App\Http\Controllers\web;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\api_helper;
use App\Models\Monitor; 
use App\Models\User; 
use App\Models\Servey;
use App\Models\Questions;
use App\Models\QuestionOptions;
use App\Models\RatingFeedbackQuestionDetails;
use App\Models\RatingQuestionDetails;
use App\Models\RatingQuestionOptions;
use Config;
use Illuminate\Support\Facades\Schema;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Schema\Blueprint;
use Session;


class FeedbackController extends Controller
{
    function giveRating($monitor_id)
    { 
        //$response_data = $request->session()->get('response_data');
        //echo '<pre>';print_r(Session::get('response_data'));echo '</pre>';
        // $response_data = Session::get('response_data');
        // $removeDuplication = array_values(array_column($response_data, null, 'question_id'));
        // echo '<pre>';print_r($removeDuplication);echo '</pre>';
        $encode_monitor_id=$monitor_id;
        $monitor_id = desc_text($monitor_id);
        $params = \Request::query();

        if(isset($params['sort']) && !empty($params['sort'])){
            $sort=$params['sort'];
        }else{
            $sort=1;  
        }
        $data['sort']=$sort;
        $data['monitor_id']=$monitor_id;
        
        $monitor = Monitor::where('id',$monitor_id)->get()->first();
        if(!empty($monitor)){
            $data['monitor'] = $monitor;
            $company_id = $monitor->company_id;
            $servey_id = $monitor->servey_id;
            //// servey details /////
            $servey_details = Servey::where('id',$servey_id)->get()->first();
            $data['servey_details']=$servey_details;
            //// Get company profile pic ///////
            $company_details = User::select('profile_photo_path')->where('id',$company_id)->get()->first();
            $data['profile_pic'] = !empty($company_details->profile_photo_path) ? url($company_details->profile_photo_path) : '';
            ///// Get Advertise ///////
            $data['advertisements']=array();
            $advert_images = [];
            if (Schema::connection('mysql2')->hasTable('servey_advertise')) {
                $servey_advertise = \App\Models\ServeyAdvert::select('image')->where('servey_id',$servey_id)->get()->toArray();
                $data['advertisements'] = $servey_advertise;
                if(!empty($servey_advertise))
                {
                    foreach($servey_advertise as $k=>$s)
                    {
                        $advert_images[] = url($s['image']);
                    }
                }
            }
            $data['advertisements']=$advert_images;
            ///// Get question //////
            $data['questions']=[];$is_other_positive=$is_other_negative=0;
            if (Schema::connection('mysql2')->hasTable('questions')) {
                
                $question_list = Questions::with('options','servey_feedback_questions','sub_questions')->where('servey_id',$servey_id)->where('order',$sort)->orderBy('id','ASC')->get()->first();
                $data['questions']=$question_list;

                $is_last_question=0;
                if(!empty($question_list))
                {
                    $last_question_id = Questions::with('options','servey_feedback_questions','sub_questions')->where('servey_id',$monitor->servey_id)->orderBy('order','DESC')->take(1)->get()->first()->id;
                    $data['last_question_id']=$last_question_id;
                    
                    if($last_question_id==$question_list->id)
                    {
                        if($servey_details->ask_customer_details==1){
                            $data['ask_cust_question']=1;
                        }else{
                            $data['ask_cust_question']=0;
                        }
                        $is_last_question=1;
                    }
                }
                if(!empty($question_list->servey_feedback_questions))
                {
                    $data['positive_que']=$data['negative_que']=[];
                    $i=$j=0;
                    foreach($question_list->servey_feedback_questions as $sf)
                    {
                        if($sf->response_tone==1 && $sf->feedback_question_id==0)
                        {
                            $is_other_positive=1;
                        }
                        if($sf->response_tone==2 && $sf->feedback_question_id==0)
                        {
                            $is_other_negative=1;
                        }
                        $que_id=$sf->feedback_question_id;

                        if($sf->feedback_question_id!=0)
                        {
                            $question= \App\Models\FeedbackQuestion::select('id','question')->where('id',$sf->feedback_question_id)->get()->first()->question;
                        }
                        if($sf->response_tone==1 && $sf->feedback_question_id!=0)
                        {
                            $data['positive_que'][$i]['que_id'] = $que_id;
                            $data['positive_que'][$i]['question'] = $question;

                            $i++;
                        }else if($sf->response_tone==2 && $sf->feedback_question_id!=0){
                            $data['negative_que'][$j]['que_id'] = $que_id;
                            $data['negative_que'][$j]['question'] = $question;

                            $j++;
                        }
                    }
                }
            }
        }else{
            abort(404);
        }
        //dd($data);
        return view('web.landing',['data'=>$data,'is_last_question'=>$is_last_question,'monitor_id'=>$monitor_id,'encode_monitor_id'=>$encode_monitor_id,'is_other_positive'=>$is_other_positive,'is_other_negative'=>$is_other_negative,'sort'=>$sort]);
    }

    // function giveRating1($monitor_id)
    // {
    //     echo $monitor_id;
    // }
    function save(Request $request,$id)
    {
        $monitor_id=$id;
        $encode_monitor_id = enc_text($id);
        $monitor = Monitor::where('id',$monitor_id)->get()->first();
        $save_data['monitor_id']=$monitor_id;
        $save_data['company_id'] = $monitor->company_id;
        $save_data['site_id'] = $monitor->site_id;
        $save_data['servey_id'] = $monitor->servey_id;

        $sort = $request->sort;
        if(isset($request->name) || isset($request->email) || isset($request->phone_no))
        {
            $customer_data['name']=$request->name;
            $customer_data['email']=$request->email;
            $customer_data['phone_no']=$request->phone_no;

            $customer_data = $request->session()->put('customer_data', $customer_data);
            //print_r(Session::get('customer_data'));
        }
        if($request->question_type == 1 || $request->question_type == 2 || $request->question_type == 4 || $request->question_type == 6 || $request->question_type == 7)
        {
            // if($request->rating == NULL || $request->rating == '')
            // {
            //     echo 'R';exit;
            // }
        }
        $rating = $request->rating;
        $question_id = $request->question_id;

        $question_data = Questions::where('id',$question_id)->get()->first();
        $res_data['rating'] = ($request->rating==NULL) ? '' : $request->rating;
        $res_data['question_id'] = $request->question_id;
        $res_data['question_type'] = $request->question_type;
        $res_data['option_ids'] = [];
        $res_data['options_value'] = []; 
        $res_data['sub_questions'] = []; 

        // $positive_tone_count= !empty(Session::get('positive_tone_count')) ? Session::get('positive_tone_count') : 0;
        // $negative_tone_count= !empty(Session::get('negative_tone_count')) ? Session::get('negative_tone_count') : 0;
        // $neutral_tone_count= !empty(Session::get('neutral_tone_count')) ? Session::get('neutral_tone_count') : 0;;

     
        // $request->session()->put('positive_tone_count', $positive_tone_count);
        // $request->session()->put('negative_tone_count', $negative_tone_count);
        // $request->session()->put('neutral_tone_count', $neutral_tone_count);
       
        // $positive_count_data = Session::get('positive_tone_count');
        // $negative_count_data = Session::get('negative_tone_count');
        // $neutral_count_data = Session::get('neutral_tone_count');
       
        if($request->question_type==1)
        {
            if($rating==1 || $rating == 2)
            {
                $response_tone=3;
                //$negative_tone_count = $negative_count_data + 1;
                //$request->session()->put('negative_tone_count', $negative_tone_count);

            }
            // else if($rating == 3){
            //     $response_tone=2;
            //     //$neutral_tone_count += 1;
            //     //$neutral_tone_count = $neutral_count_data + 1;
            //     //$request->session()->put('neutral_tone_count', $neutral_tone_count);

            // }
            else if($rating == 3 || $rating == 4){
                $response_tone=1;
                //$positive_tone_count += 1;
                //$positive_tone_count = $positive_count_data + 1;
                //$request->session()->put('positive_tone_count', $positive_tone_count);

            }else{
                $response_tone=1;  
            }
        }else if($request->question_type==2)
        {
            if($rating < 3)
            {
                $response_tone=3;
                //$negative_tone_count = $negative_count_data + 1;
                //$request->session()->put('negative_tone_count', $negative_tone_count);
                
            }else if($rating == 3){
                $response_tone=2;
                //$neutral_tone_count = $neutral_count_data + 1;
                //$request->session()->put('neutral_tone_count', $neutral_tone_count);

            }else if($rating >= 4){
                $response_tone=1;
                //$positive_tone_count = $positive_count_data + 1;
                //$request->session()->put('positive_tone_count', $positive_tone_count);

            }else{
                $response_tone=1; 
            }
        }else if($request->question_type==4)
        {
            $icon_type = $question_data->icon_type;
            if($icon_type==1 || $icon_type==3 || $icon_type==5){
                if($rating < 3)
                {
                    $response_tone=3;
                    //$negative_tone_count = $negative_count_data + 1;
                    //$request->session()->put('negative_tone_count', $negative_tone_count);

                }else if($rating == 3){
                    $response_tone=2;
                    //$neutral_tone_count = $neutral_count_data + 1;
                    //$request->session()->put('neutral_tone_count', $neutral_tone_count);

                }else if($rating >= 4){
                    $response_tone=1;
                    //$positive_tone_count = $positive_count_data + 1;
                    //$request->session()->put('positive_tone_count', $positive_tone_count);
                }else{
                    $response_tone=1;
                }
            }
            if($icon_type==2 || $icon_type==4 || $icon_type==6){
                if($rating < 5)
                {
                    $response_tone=3;
                    //$negative_tone_count = $negative_count_data + 1;
                    //$request->session()->put('negative_tone_count', $negative_tone_count);

                }else if($rating == 5 || $rating == 6){
                    $response_tone=2;
                    //$neutral_tone_count = $neutral_count_data + 1;
                    //$request->session()->put('neutral_tone_count', $neutral_tone_count);

                }else if($rating >= 7){
                    $response_tone=1;
                    //$positive_tone_count = $positive_count_data + 1;
                    //$request->session()->put('positive_tone_count', $positive_tone_count);

                }else{
                    $response_tone=1;
                }
            }
        }else if($request->question_type==6)
        {
            if(!empty($rating) || $rating!=NULL){
                $yes_no_response_tone = QuestionOptions::select('response_tone')->where('question_id',$question_id)->where('option_id',$rating)->first()->response_tone;
                if($yes_no_response_tone==1){
                    $response_tone=1;
                    //$positive_tone_count = $positive_count_data + 1;
                    //$request->session()->put('positive_tone_count', $positive_tone_count);
    
                }else{
                    $response_tone=3;
                    //$negative_tone_count = $negative_count_data + 1;
                    //$request->session()->put('negative_tone_count', $negative_tone_count);
                }
            }else{
                $response_tone=1;
            }
            
        }else if($request->question_type==7){
            $response_tone=0;
        }
        if($request->question_type==3 || $request->question_type==5 || $request->question_type==8)
        {
            $feedback_options = isset($request->option_ids) ? $request->option_ids : [];
            $fd_opts=[];
            $positive_opt_count=$negative_opt_count=0;

            $response_tone=1;
            if(!empty($feedback_options))
            {
                foreach($feedback_options as $fo)
                {
                    if($fo != 0)
                    {
                        $options = \App\Models\QuestionOptions::select('options','response_tone')->where('question_id',$request->question_id)->where('id',$fo)->get()->first();
                        $fd_opts[] = $options->options;
        
                        //// calculate response tone //////
                        $response_tone = $options->response_tone;
                        if($response_tone==1){
                            $response_tone=1;
                            $positive_opt_count++;
                        }else{
                            $response_tone=3;
                            $negative_opt_count++;
                        }
                    }else{
                        $response_tone=0;
                    }
                }
                if(isset($request->other_mul_opt_val) && !empty($request->other_mul_opt_val))
                {
                    array_push($fd_opts,$request->other_mul_opt_val);
                }
                if($positive_opt_count > $negative_opt_count)
                {
                    $response_tone=1;
                    //$positive_tone_count += 1;
                    //$positive_tone_count = $positive_count_data + 1;
                    //$request->session()->put('positive_tone_count', $positive_tone_count);

                }else if($positive_opt_count == $negative_opt_count){
                    $response_tone=2;
                    //$neutral_tone_count += 1;
                    //$neutral_tone_count = $neutral_count_data + 1;
                    //$request->session()->put('neutral_tone_count', $neutral_tone_count);

                }else if($positive_opt_count < $negative_opt_count){
                    $response_tone=3;
                    //$negative_tone_count += 1;
                    //$negative_tone_count = $negative_count_data + 1;
                    //$request->session()->put('negative_tone_count', $negative_tone_count);
                }else{
                    $response_tone=1;
                }
            }
            $res_data['option_ids'] = isset($request->option_ids) ? ($request->option_ids) : [];
            $res_data['options_value'] = !empty($fd_opts) ? ($fd_opts) : [];
        }

        if($request->question_type==9)
        {
            ////// make subquestion json //////
            $que_option_data=$final_que_data=array();
            if(isset($request->sub_question_id) && !empty($request->sub_question_id))
            {
                $positive_opt_count=$negative_opt_count=0;
                foreach($request->sub_question_id as $sub)
                {
                    $opt = 'option_id_for_question_'.$sub;
                    if(isset($request->$opt))
                    {
                        $que_option_data['id'] = $sub;
                        $sub_que = \App\Models\SubQuestions::select('subquestion')->where('question_id',$request->question_id)->where('id',$sub)->get()->first();
                        $que_option_data['sub_question'] = !empty($sub_que) ? $sub_que->subquestion : '';
                        $que_option_data['option_id'] = $request->$opt;
                        $question_options = \App\Models\QuestionOptions::select('options','response_tone')->where('question_id',$request->question_id)->where('id',$request->$opt)->get()->first();
                        $que_option_data['options_value'] = !empty($question_options) ? $question_options->options : '';
                        $final_que_data[] = $que_option_data;

                        ////// calculate response tone //////
                        if($request->$opt != 0)
                        {
                            $get_response_tone = $question_options;
                            if($get_response_tone->response_tone==1){
                                $response_tone=1;
                                $positive_opt_count++;
                            }else{
                                $response_tone=3;
                                $negative_opt_count++;
                            }
                        }else{
                            $response_tone=0;
                        }
                    }
                }
                if($positive_opt_count > $negative_opt_count)
                {
                    $response_tone=1;
                    //$positive_tone_count += 1;
                }else if($positive_opt_count == $negative_opt_count){
                    $response_tone=2;
                    //$neutral_tone_count += 1;
                }else if($positive_opt_count < $negative_opt_count){
                    $response_tone=3;
                    //$negative_tone_count += 1;
                }
                // echo '<pre>';print_r($final_que_data);echo '</pre>';
                // exit;
            }
            $res_data['sub_questions'] = $final_que_data;
        }

        $feedback_questions = isset($request->feedback_que_ids) ? $request->feedback_que_ids : [];
        $feedback_question_values="";$fd_que=[];
        if(!empty($feedback_questions))
        {
            foreach($feedback_questions as $q)
            {
                if($q != 0)
                {
                    $fd_que[] = \App\Models\FeedbackQuestion::select('id','question')->where('id',$q)->get()->first()->question;
                }
            }
        }
        if(isset($request->feedback_option) && !empty($request->feedback_option))
        {
            array_push($fd_que,$request->feedback_option);
        }
        $feedback_question_values = $fd_que;

        $res_data['response_tone'] = ($request->question_type==7) ? 0 : $response_tone;
        $res_data['feedback_question_ids'] = isset($request->feedback_que_ids) ? ($request->feedback_que_ids) : [];
        $res_data['feedback_question_values'] = $feedback_question_values;
        
       ////// Other Data /////////
        // $positive_count_data = Session::get('positive_tone_count');
        // $negative_count_data = Session::get('negative_tone_count');
        // $neutral_count_data = Session::get('neutral_tone_count');
        // $respo_data['positive_count_data'] = $positive_count_data; 
        // $respo_data['negative_count_data'] = $negative_count_data; 
        // $respo_data['neutral_count_data'] = $neutral_count_data; 


        // $positive_tone_count = !empty(Session::get('positive_tone_count'))? Session::get('positive_tone_count') : 0;
        // $negative_tone_count = !empty(Session::get('negative_tone_count')) ?  Session::get('negative_tone_count') : 0;
        // $neutral_tone_count = !empty(Session::get('neutral_tone_count')) ?  Session::get('neutral_tone_count') : 0;

        // $raings['positive'] = $positive_tone_count;
        // $raings['negative'] = $negative_tone_count;
        // $raings['nuetral'] = $neutral_tone_count;

        // $question_count = $positive_tone_count+$negative_tone_count+$neutral_tone_count;
        // $raings['question_count'] = $question_count;
        // $positive_tone_performance =  ($question_count!=0) ? $positive_tone_count/$question_count : 0;
        // $negative_tone_performance =  ($question_count!=0) ? $negative_tone_count/$question_count : 0;
        // $neutral_tone_performance =  ($question_count!=0) ? $neutral_tone_count/$question_count : 0;
        // $final_performance = max($positive_tone_performance,$negative_tone_performance,$neutral_tone_performance);
        
        // $array = array($positive_tone_count,$negative_tone_count,$neutral_tone_count);
        // $maxs = array_keys($array, max($array));
        
        // if($maxs[0]==0) 
        //     $performance =1;
        // else if($maxs[0]==1)
        //     $performance =3;
        // else
        //     $performance =2;

        
        // $raings['positive_avg'] = $positive_tone_performance;
        // $raings['negative_avg'] = $negative_tone_performance;
        // $raings['neutral_avg'] = $neutral_tone_performance;
        // $raings['positive_per'] = ($positive_tone_performance*100);
        // $raings['negative_per'] = ($negative_tone_performance*100);
        // $raings['neutral_per'] = ($neutral_tone_performance*100);


        // $raings['performance']=$performance;


        $post_data[] = $res_data;

       
        if(!$request->session()->has('question_data')) {
            $question_data = $request->session()->put('question_data', $save_data);
        }

        // if(!$request->session()->has('rating_data')) {
        //     $rating_data = $request->session()->put('rating_data', $raings);
        // }else{
        //     $request->session()->forget('rating_data');
        //     $rating_data = $request->session()->put('rating_data', $raings);
        // }

        if(!$request->session()->has('response_data')) {
            $response_data = $request->session()->put('response_data', $post_data);
        }else{
            $response_data = $request->session()->get('response_data');
            $new_response_data = array_push($response_data, $res_data);
            $request->session()->put('response_data', $response_data);
        }

        // $final_data = $request->session()->get('response_data');;
        // $removeDuplication = array_values(array_column($final_data, null, 'question_id'));
        
        $is_other_positive=$is_other_negative=0;

        $params = \Request::query();
      
        $sort = $request->sort;
        
        //// servey details /////
        $servey_details = Servey::where('id',$monitor->servey_id)->get()->first();
        $data['servey_details']=$servey_details;

        if (Schema::connection('mysql2')->hasTable('questions')) {
            //$question_list = Questions::with('options','servey_feedback_questions')->where('servey_id',$monitor->servey_id)->where('id','>',$request->question_id)->orderBy('id','ASC')->get()->first();
            //echo Questions::with('options','servey_feedback_questions')->where('servey_id',$monitor->servey_id)->where('order',$sort)->orderBy('id','ASC')->toSql();
            $question_list = Questions::with('options','servey_feedback_questions','sub_questions')->where('servey_id',$monitor->servey_id)->where('order',$sort)->orderBy('id','ASC')->get()->first();
            //$quries = DB::getQueryLog();
            $data['questions']=$question_list;
            $is_last_question=0;
            if(!empty($question_list))
            {
                $last_question_id = Questions::with('options','servey_feedback_questions','sub_questions')->where('servey_id',$monitor->servey_id)->orderBy('order','DESC')->skip(1)->take(1)->get()->first()->id;
                $data['last_question_id']=$last_question_id;
                if($last_question_id==$question_list->id)
                {
                    if($servey_details->ask_customer_details==1){
                        $data['ask_cust_question']=1;
                    }else{
                        $data['ask_cust_question']=0;
                    }
                    $is_last_question=1;
                }
            }
            if(!empty($question_list->servey_feedback_questions))
            {
                $data['positive_que']=$data['negative_que']=[];
                $i=$j=0;
                foreach($question_list->servey_feedback_questions as $sf)
                {
                    $que_id=$sf->question_id;

                    if($sf->response_tone==1 && $sf->feedback_question_id==0)
                    {
                        $is_other_positive=1;
                    }
                    if($sf->response_tone==2 && $sf->feedback_question_id==0)
                    {
                        $is_other_negative=1;
                    }

                    if($sf->feedback_question_id!=0)
                    {
                        $question= \App\Models\FeedbackQuestion::select('id','question')->where('id',$sf->feedback_question_id)->get()->first()->question;
                    }
                    if($sf->response_tone==1 && $sf->feedback_question_id!=0)
                    {
                        $data['positive_que'][$i]['que_id'] = $sf->feedback_question_id;
                        $data['positive_que'][$i]['question'] = $question;

                        $i++;
                    }else if($sf->response_tone==2 && $sf->feedback_question_id!=0){
                        $data['negative_que'][$j]['que_id'] = $sf->feedback_question_id;
                        $data['negative_que'][$j]['question'] = $question;

                        $j++;
                    }
                }
            }
        }
        return view('web.questions.next',['data'=>$data,'is_last_question'=>$is_last_question,'encode_monitor_id'=>$encode_monitor_id,'post_data'=>$res_data,'is_other_positive'=>$is_other_positive,'is_other_negative'=>$is_other_negative,'monitor_id'=>$monitor_id,'sort'=>$sort]);
        // return response()->json([
        //     'success' => true,
        //     'data' => $response_data,
        //     'sort' => $sort
        // ]);
        //$rensonse = json_encode();
    }

    
    public function insert(Request $request,$monitor_id)
    {
        //echo '<pre>';print_r(Session::get('customer_data'));echo '</pre>';exit;
        $question_data = Session::get('question_data');
        //echo '<pre>';print_r($question_data);echo '</pre>';exit;

        $save_data = new \App\Models\Ratings;
        $save_data['monitor_id']=$question_data['monitor_id'];
        $save_data['company_id'] = $question_data['company_id'];
        $save_data['site_id'] = $question_data['site_id'];
        $save_data['servey_id'] = $question_data['servey_id'];
        $save_data['date'] = date('Y-m-d');
        $save_data['time'] = date('H:i:s');
        $save_data['datetime'] = date('Y-m-d H:i:s');
        $final_response_data = Session::get('response_data');
        $removeDuplication = array_values(array_column($final_response_data, null, 'question_id'));
        $save_data['servey_response']=json_encode($removeDuplication);


        //$rating_data = Session::get('rating_data');


        $rating_counts = array_count_values(
            array_column($removeDuplication, 'response_tone')
        );
        
       
        $positive_tone_count = isset($rating_counts[1]) ? $rating_counts[1] : 0;
        $negative_tone_count = isset($rating_counts[3]) ? $rating_counts[3] : 0;
        $neutral_tone_count = isset($rating_counts[2]) ? $rating_counts[2] : 0;
        
        $question_count = $positive_tone_count+$negative_tone_count+$neutral_tone_count;
        
        $positive_tone_performance =  ($question_count!=0) ? $positive_tone_count/$question_count : 0;
        $negative_tone_performance =  ($question_count!=0) ? $negative_tone_count/$question_count : 0;
        $neutral_tone_performance =  ($question_count!=0) ? $neutral_tone_count/$question_count : 0;
        $final_performance = max($positive_tone_performance,$negative_tone_performance,$neutral_tone_performance);
        
        $array = array($positive_tone_count,$negative_tone_count,$neutral_tone_count);
        $maxs = array_keys($array, max($array));
        
        if($maxs[0]==0) 
            $performance =1;
        else if($maxs[0]==1)
            $performance =3;
        else
            $performance =2;


        // $save_data['positive']=$rating_data['positive'];
        // $save_data['negative']=$rating_data['negative'];
        // $save_data['nuetral']=$rating_data['nuetral'];
        $save_data['positive']= $positive_tone_count;
        $save_data['negative']= $negative_tone_count;
        $save_data['nuetral']= $neutral_tone_count;
        $save_data['positive_avg']=$positive_tone_performance;
        $save_data['negative_avg']=$negative_tone_performance;
        $save_data['neutral_avg']=$neutral_tone_performance;
        $save_data['positive_per']=($positive_tone_performance*100);
        $save_data['negative_per']=($negative_tone_performance*100);
        $save_data['neutral_per']=($neutral_tone_performance*100);
        $save_data['performance']=$performance;
        $save_data['created_at']=$save_data['updated_at']=date('Y-m-d H:i:s');

        // $save_data['positive_avg']=$rating_data['positive_avg'];
        // $save_data['negative_avg']=$rating_data['negative_avg'];
        // $save_data['neutral_avg']=$rating_data['neutral_avg'];
        // $save_data['positive_per']=$rating_data['positive_per'];
        // $save_data['negative_per']=$rating_data['negative_per'];
        // $save_data['neutral_per']=$rating_data['neutral_per'];
        // $save_data['performance']=$rating_data['performance'];
        
        $rating_id = $save_data->save();
        if($rating_id)
        {
            //////// save cutomer details ///////
            $customer_data = Session::get('customer_data');
            if(!empty($customer_data['name']) || !empty($customer_data['email']) || !empty($customer_data['phone_no']))
            {
                $customer_details = \App\Models\RatingCustomerDetails::create([
                    'rating_id' => $save_data->id,
                    'name' => isset($customer_data['name']) ? $customer_data['name'] : '',
                    'email' => isset($customer_data['email']) ? $customer_data['email'] : '',
                    'phone_no' => isset($customer_data['phone_no']) ? $customer_data['phone_no'] : '',
                ]);
            }
            ///// Save rating questions is in observer///////
            // if(!empty($removeDuplication))
            // {
            //     $question_details_data=$option_data=$feedback_que_data=array();
            //     foreach($removeDuplication as $q)
            //     {
            //         if(!empty($q['rating']) && is_numeric($q['rating']))
            //         {
            //             $question_details_data[] = [
            //                 'question_id' => $q['question_id'],
            //                 'servey_id' => $question_data['servey_id'],
            //                 'rating' => $q['rating'],
            //                 'response_tone' => $q['response_tone'],
            //                 'question_type' => $q['question_type'],
            //                 'date' => date('Y-m-d'),
            //                 'time' => date('H:i:s'),
            //                 'created_at' => date('Y-m-d H:i:s'),
            //                 'updated_at' => date('Y-m-d H:i:s')
            //             ];
            //         }

            //         ////// Question Options ////////
            //         if(!empty($q['option_ids'])){
            //             $opts = $q['option_ids'];
            //             $opt_values = $q['options_value'];
                        
            //             foreach($opts as $o=>$v)
            //             {
            //                 $option_data[] = [
            //                     'question_id' => $q['question_id'],
            //                     'question_type' => $q['question_type'],
            //                     'servey_id' => $question_data['servey_id'],
            //                     'option_id' => $v,
            //                     'option_value' => $opt_values[$o],
            //                     'date' => date('Y-m-d'),
            //                     'time' => date('H:i:s'),
            //                     'created_at' => date('Y-m-d H:i:s'),
            //                     'updated_at' => date('Y-m-d H:i:s')
            //                 ];
            //             }
            //         }

            //         ////// Question Feedback Opts ////////
            //         if(!empty($q['feedback_question_ids'])){
            //             $fds = $q['feedback_question_ids'];
            //             $fd_values = $q['feedback_question_values'];
                        
            //             //$feedback_que_data=[];
            //             foreach($fds as $k=>$f)
            //             {
            //                 $feedback_que_data[] = [
            //                     'question_id' => $q['question_id'],
            //                     'question_type' => $q['question_type'],
            //                     'servey_id' => $question_data['servey_id'],
            //                     'feedback_question_id' => $f,
            //                     'feedback_question' => $fd_values[$k],
            //                     'date' => date('Y-m-d'),
            //                     'time' => date('H:i:s'),
            //                     'created_at' => date('Y-m-d H:i:s'),
            //                     'updated_at' => date('Y-m-d H:i:s')
            //                 ];
            //             }
            //         }
            //     }
              
            //     if(!empty($question_details_data))
            //     {
            //         ///// Insert Question Details /////
            //         RatingQuestionDetails::insert($question_details_data);
            //     }
            //     ///// insert feedback questions ////
            //     if(!empty($feedback_que_data))
            //     {
            //         RatingFeedbackQuestionDetails::insert($feedback_que_data);
            //     }
            //     ///// insert options ////
            //     if(!empty($option_data))
            //     {
            //         RatingQuestionOptions::insert($option_data);
            //     }
            // }
            
            

            //Session::forget('response_data');
            $request->session()->forget('response_data');
            $request->session()->forget('customer_data');
            
            // $request->session()->forget('rating_data');
            // $request->session()->forget('positive_tone_count');
            // $request->session()->forget('negative_tone_count');
            // $request->session()->forget('neutral_tone_count');

            Session::forget('question_data');
            // Session::forget('rating_data');
            // Session::forget('positive_tone_count');
            // Session::forget('negative_tone_count');
            // Session::forget('neutral_tone_count');

            session()->flash('success', 'Thanks for rating us!');
        }  
        
    }
    function thanks($id)
    {
        Session::forget('response_data');
        Session::forget('question_data');
        // Session::forget('rating_data');
        // Session::forget('positive_tone_count');
        // Session::forget('negative_tone_count');
        // Session::forget('neutral_tone_count');
        return redirect()->route('feedback.give-rating',$id)->with('message', 'Thanks for rating us!');
    }
}
?>
