<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Facades\Config;
use Illuminate\Support\Facades\DB;

class HourlyQuestionRatings extends Model
{
    use HasFactory;

    public $connection = 'mysql2';

   
    /**
     * The table associated with the model.
     *
     * @var string
    */ 
    protected $table = 'hourly_question_ratings';

    /**
     * set primary key of table
     *
     * @var integer
     */
    //protected $primaryKey = 'id';

    /**
     * Indicates if the model should be timestamped.
     *
     * @var bool
     */
    public $timestamps = true;

    

    /**
     * fillable column name goes here
     *
     * @var array
     */
    protected $fillable = [
        'id',
        'servey_id',
        'site_id',
        'monitor_id',
        'question_id',
        'rating',
        'date',
        'time',
        '0_hr',
        '1_hr',
        '2_hr',
        '3_hr',
        '4_hr',
        '5_hr',
        '6_hr',
        '7_hr',
        '8_hr',
        '9_hr',
        '10_hr',
        '11_hr',
        '12_hr',
        '13_hr',
        '14_hr',
        '15_hr',
        '16_hr',
        '17_hr',
        '18_hr',
        '19_hr',
        '20_hr',
        '21_hr',
        '22_hr',
        '23_hr',
        'created_at',
        'updated_at',
    ];

    public function site()
    {
        return $this->hasOne('\App\Models\Site','id','site_id')->select(['id','name']);
    }

    public function monitor()
    {
        return $this->hasOne('\App\Models\Monitor','id','monitor_id');
    }

}
