<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Database\Eloquent\SoftDeletes;


class Monitor extends Model
{
    use HasFactory;
    use SoftDeletes;

    //public $connection = 'mysql2';

   
    /**
     * The table associated with the model.
     *
     * @var string
    */ 
    protected $table = 'monitors';

    /**
     * set primary key of table
     *
     * @var integer
     */
    //protected $primaryKey = 'id';

    /**
     * Indicates if the model should be timestamped.
     *
     * @var bool
     */
    public $timestamps = true;

    public function site()
    {
        return $this->hasOne('\App\Models\Site');
    }


    /**
     * fillable column name goes here
     *
     * @var array
     */
    protected $fillable = [
        'id',
        'company_id',
        'site_id',
        'servey_id',
        'monitor_key',
        'monitor_number',
        'inbuild_location',
        'build_location',
        'active',
        'created_by',
        'updated_by',
        'deleted_by'
    ];


  
}
