<?php

use Illuminate\Support\Facades\Auth;
use App\Models\User;
use App\Models\Monitor;
use App\Models\Ratings;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;


/// Note : After creating helper we need to do 2 things : /////
//// 1) Load this file in composer.json under autoload section //////
//// 2) use command composer dump-autoload /////
if(!function_exists('user_role'))
{
    function company_logo()
    {
        if(!empty(Auth::user()))
        {
            if(Auth::user()->role==3)
            {
                $company_id = Auth::user()->company_id;
                return User::where('id',$company_id)->get()->first()->profile_photo_path;
            }else{
                return Auth::user()->profile_photo_path;
            }
        }
    }

    function CID()
    {
        if(!empty(Auth::user()))
        {
            if(Auth::user()->role==3)
            {
                return $company_id = Auth::user()->company_id;
            }else{
                return Auth::user()->id;
            }
        }
    }

    function isAdminPermission()
    {
        if(!empty(Auth::user()))
        {
            if(Auth::user()->role==2)
            {
                return true;
            }else{
                return false;
            }
        }
    }

    function isManagerPermission()
    {
        if(!empty(Auth::user()))
        {
            if(Auth::user()->role==3)
            {
                return true;
            }else{
                return false;
            }
        }
    }

    function UploadFile($file,$path)
    {
        //$image = time().'_'.$path->getClientOriginalName();
        $image = time().rand(1,99).'.'.$file->extension();
        $file->move(public_path($path), $image);
        return $image_path = $path.'/'.$image;
    }
    
    function DeleteFile($path)
    {
        if (file_exists(public_path($path))) {
            $delete = File::delete(public_path($path));   
            if($delete){
                return true;
            }else{ return false; }     
        }
    }

    
}

function hourly_graph_data($monitor_id,$from_date,$to_date)
{
    $data['jsonTable'] = '';
    ///// Feedback calc ///////
    $hourly_data = with(new Ratings)->rating_in_per_houlrly_chart_data($monitor_id,$from_date,$to_date); 
    //echo '<pre>';print_r($hourly_data);echo '</pre>';exit;
    
    $table = $table2 = array();
    $table['cols'] = array(

    // Labels for your chart, these represent the column titles
    array('label' => 'Hour', 'type' => 'string'),
    array('label' => 'Positive', 'type' => 'number'),
    array('label' => 'Neutral', 'type' => 'number'),
    array('label' => 'Negative', 'type' => 'number'),
    );

    $table2['cols'] = array(
        // Labels for your chart, these represent the column titles
        array('label' => 'Hour', 'type' => 'string'),
        array('label' => 'Positive', 'type' => 'number'),
        array('label' => 'Neutral', 'type' => 'number'),
        array('label' => 'Negative', 'type' => 'number'),
        );

    $rows = $rows_per = array();

    $linechart_data=$linechart_data_per=$final_heat_data=array();
    $hour_sum=$positive_per=$neutral_per=$negative_per=0;

    $final_pos_heat_data = $heat_neg_data = $heat_neu_data = array();
    for ($t = 0; $t <= 23; $t++) {

        $col_name='r'.$t;
        if(!empty($hourly_data))
        {
            $hour_sum = $hourly_data[0]->$col_name + $hourly_data[1]->$col_name + $hourly_data[2]->$col_name;
            $positive_per = (!empty($hour_sum)) ? ceil(($hourly_data[0]->$col_name*100/$hour_sum)) : 0;
            $neutral_per = (!empty($hour_sum)) ? ceil($hourly_data[1]->$col_name*100/$hour_sum) : 0;
            $negative_per = (!empty($hour_sum)) ? ceil($hourly_data[2]->$col_name*100/$hour_sum) : 0;
        }
        $linechart_data['total_positive_feedback'] = $positive_per;
        $linechart_data['total_neutral_feedback'] = $neutral_per;
        $linechart_data['total_negetive_feedback'] = $negative_per;

        /////// Number of Feedback /////
        $sub_array=array();
        $sub_array[] =  array(
            "v" => "$t"
        );
        $sub_array[] =  array(
            "v" => $linechart_data['total_positive_feedback']
        );
        $sub_array[] =  array(
            "v" => $linechart_data['total_neutral_feedback']
        );
        $sub_array[] =  array(
            "v" => $linechart_data['total_negetive_feedback']
        );
        
        $rows[] =  array(
            "c" => $sub_array
        );

        /////// Heat map data /////
        $heat_data = array();

        // $heat_data[] =  array(
        //     "y" => "$t"
        // );
        // $sub_array[] =  array(
        //     "x" => $linechart_data['total_positive_feedback']
        // );

        // $heat_pos_data["x"] = "Positive";
        // $heat_pos_data["y"] = $t;
        // $heat_pos_data["heat"] = $linechart_data['total_positive_feedback'];

        $heat_neu_data["x"] = $t;
        $heat_neu_data["y"] = "Neutral";
        $heat_neu_data["heat"] = $linechart_data['total_neutral_feedback'];

        $heat_neg_data["x"] = $t;
        $heat_neg_data["y"] = "Negative";
        $heat_neg_data["heat"] = $linechart_data['total_negetive_feedback'];

        //$final_pos_heat_data[] = $heat_pos_data;
        $final_neu_heat_data[] = $heat_neu_data;
        $final_neg_heat_data[] = $heat_neg_data;
    }
    $final_heat_data = array_merge($final_neu_heat_data,$final_neg_heat_data);
    $table['rows'] = $rows;
    $data['jsonTable'] = json_encode($table);
    $data['heat_map_data'] = json_encode($final_heat_data);

   // echo json_encode($final_heat_data);
    return $data;
}

function heat_map_dashboard_data()
{
    
}

function question_details($que_id)
{
    $question = \App\Models\Questions::with('options','servey_feedback_questions')->where('id',$que_id)->get()->toArray();
    if(!empty($question))
    {
        $data['id']=$question['id'];
        $data['servey_id']=$question['servey_id'];
        $data['question']=$question['question'];
        $data['order']=$question['order'];
        $data['description']=$question['description'];
        $data['positive_title']=$question['positive_title'];
        $data['negative_title']=$question['negative_title'];
        $data['question_type']=$question['question_type'];
        $data['icon_type']=$question['icon_type'];
        $data['is_multi_seleted']=$question['is_multi_seleted'];
        $data['other']=$question['other'];

        ///// Get Question Options : if question has multi option //////////////////
        $data['options_data'] = $question['options'];

        //$data['servey_feedback_questions'] = $question['servey_feedback_questions'];
        //// Get +/- questions list ///////
        if(!empty($question['servey_feedback_questions']))
        {
            $j=0;
            foreach($question['servey_feedback_questions'] as $fd)
            {
                $data['feedback_questions'][$j]['id'] = $fd['id'];
                $data['feedback_questions'][$j]['feedback_question_id'] = $fd['feedback_question_id'];
                $data['feedback_questions'][$j]['response_tone'] = $fd['response_tone'];
                if(!empty($fd['feedback_question_id']))
                {
                    $data['feedback_questions'][$j]['feedback_question'] = \App\Models\FeedbackQuestion::select('question','question_type','issue_type')->where('id',$fd['feedback_question_id'])->first();
                }else{
                    $data['feedback_questions'][$j]['feedback_question']['question']='Other';
                    $data['feedback_questions'][$j]['feedback_question']['question_type']=($fd['response_tone']==1) ? 1 : 2;
                    $data['feedback_questions'][$j]['feedback_question']['issue_type']=0;
                }
                
                $j++;
            }
        }
                      
    }
}

function question_data($servey_id,$sort)
{
    if (Schema::connection('mysql2')->hasTable('questions')) {
                
        $question_list = Questions::with('options','servey_feedback_questions')->where('servey_id',$servey_id)->where('order',$sort)->orderBy('id','ASC')->get()->first();
        $data['questions']=$question_list;

        $is_last_question=0;
        if(!empty($question_list))
        {
            $last_question_id = Questions::with('options','servey_feedback_questions')->where('servey_id',$monitor->servey_id)->orderBy('order','DESC')->skip(1)->take(1)->get()->first()->id;
            $data['last_question_id']=$last_question_id;
            if($last_question_id==$question_list->id)
            {
                $is_last_question=1;
            }
        }
        if(!empty($question_list->servey_feedback_questions))
        {
            $data['positive_que']=$data['negative_que']=[];
            $i=$j=0;
            foreach($question_list->servey_feedback_questions as $sf)
            {
                if($sf->response_tone==1 && $sf->feedback_question_id==0)
                {
                    $is_other_positive=1;
                }
                if($sf->response_tone==2 && $sf->feedback_question_id==0)
                {
                    $is_other_negative=1;
                }
                $que_id=$sf->feedback_question_id;

                if($sf->feedback_question_id!=0)
                {
                    $question= \App\Models\FeedbackQuestion::select('id','question')->where('id',$sf->feedback_question_id)->get()->first()->question;
                }
                if($sf->response_tone==1 && $sf->feedback_question_id!=0)
                {
                    $data['positive_que'][$i]['que_id'] = $que_id;
                    $data['positive_que'][$i]['question'] = $question;

                    $i++;
                }else if($sf->response_tone==2 && $sf->feedback_question_id!=0){
                    $data['negative_que'][$j]['que_id'] = $que_id;
                    $data['negative_que'][$j]['question'] = $question;

                    $j++;
                }
            }
        }
    }
}


function question_hourly_graph_data_local($question_ids,$from_date,$to_date)
{
    $data['jsonTable'] = '';
    ///// Feedback calc ///////
    $hourly_data = with(new Ratings)->question_rating_in_per_houlrly_chart_data($question_ids,$from_date,$to_date); 
    //echo '<pre>';print_r($hourly_data);echo '</pre>';exit;
    
    $table = $table2 = array();
    $table['cols'] = array(

    // Labels for your chart, these represent the column titles
    array('label' => 'Hour', 'type' => 'string'),
    array('label' => 'Positive', 'type' => 'number'),
    array('label' => 'Neutral', 'type' => 'number'),
    array('label' => 'Negative', 'type' => 'number'),
    );

    $table2['cols'] = array(
        // Labels for your chart, these represent the column titles
        array('label' => 'Hour', 'type' => 'string'),
        array('label' => 'Positive', 'type' => 'number'),
        array('label' => 'Neutral', 'type' => 'number'),
        array('label' => 'Negative', 'type' => 'number'),
        );

    $rows = $rows_per = array();

    $linechart_data=$linechart_data_per=array();
    $hour_sum=$positive_per=$neutral_per=$negative_per=0;
    for ($t = 0; $t <= 23; $t++) {

        $col_name='r'.$t;
        if(!empty($hourly_data))
        {
            //echo '<pre>';print_r($hourly_data[0]);echo '</pre>';
            $positive_ar = (isset($hourly_data[0]) && !empty($hourly_data[0])) ? $hourly_data[0]->$col_name  : 0;
            $neutral_ar = (isset($hourly_data[1]) && !empty($hourly_data[1])) ? $hourly_data[1]->$col_name  : 0;
            $negative_ar = (isset($hourly_data[2]) && !empty($hourly_data[2])) ? $hourly_data[2]->$col_name  : 0;
           //$hour_sum = $hourly_data[0]->$col_name + $hourly_data[1]->$col_name + $hourly_data[2]->$col_name;
           $hour_sum = $positive_ar + $neutral_ar + $negative_ar;
           $positive_per = (!empty($hour_sum)) ? ceil(($positive_ar*100/$hour_sum)) : 0;
           $neutral_per = (!empty($hour_sum)) ? ceil($neutral_ar*100/$hour_sum) : 0;
           $negative_per = (!empty($hour_sum)) ? ceil($negative_ar*100/$hour_sum) : 0;
        }
        
        $linechart_data['total_positive_feedback'] = $positive_per;
        $linechart_data['total_neutral_feedback'] = $neutral_per;
        $linechart_data['total_negetive_feedback'] = $negative_per;

        /////// Number of Feedback /////
        $sub_array=array();
        $sub_array[] =  array(
            "v" => "$t"
        );
        $sub_array[] =  array(
            "v" => $linechart_data['total_positive_feedback']
        );
        $sub_array[] =  array(
            "v" => $linechart_data['total_neutral_feedback']
        );
        $sub_array[] =  array(
            "v" => $linechart_data['total_negetive_feedback']
        );
        
        $rows[] =  array(
            "c" => $sub_array
        );

    }
    $table['rows'] = $rows;
    $data['jsonTable'] = json_encode($table);

    return $data;
}

function question_hourly_graph_data($question_ids,$from_date,$to_date)
{
    $data['jsonTable'] = '';
    ///// Feedback calc ///////
    $hourly_data = with(new Ratings)->question_rating_in_per_houlrly_chart_data($question_ids,$from_date,$to_date); 
    //echo '<pre>';print_r($hourly_data);echo '</pre>';
    
    $table = $table2 = array();
    $table['cols'] = array(

    // Labels for your chart, these represent the column titles
    array('label' => 'Hour', 'type' => 'string'),
    array('label' => 'Positive', 'type' => 'number'),
    array('label' => 'Neutral', 'type' => 'number'),
    array('label' => 'Negative', 'type' => 'number'),
    );

    $table2['cols'] = array(
        // Labels for your chart, these represent the column titles
        array('label' => 'Hour', 'type' => 'string'),
        array('label' => 'Positive', 'type' => 'number'),
        array('label' => 'Neutral', 'type' => 'number'),
        array('label' => 'Negative', 'type' => 'number'),
        );

    $rows = $rows_per = array();

    $linechart_data=$linechart_data_per=array();

    //$positive_index=$negative_index=$neutral_index='';
    if(!empty($hourly_data))
    {
        $positive_index = array_search(1, array_column($hourly_data, 'rating'));
        $negative_index = array_search(3, array_column($hourly_data, 'rating'));
        $neutral_index = array_search(2, array_column($hourly_data, 'rating'));
    }
    $hour_sum=$positive_per=$neutral_per=$negative_per=0;
    for ($t = 0; $t <= 23; $t++) {

        $col_name='r'.$t;
        
        //echo '<pre>';print_r($hourly_data);echo '</pre>';
        $positive_ar = (isset($positive_index) && is_numeric($positive_index)) ? $hourly_data[$positive_index]->$col_name  : 0;
        $neutral_ar = (isset($neutral_index) && is_numeric($neutral_index)) ? $hourly_data[$neutral_index]->$col_name  : 0;
        $negative_ar = (isset($negative_index) && is_numeric($negative_index)) ? $hourly_data[$negative_index]->$col_name  : 0;
        //echo 'positive_index :'.$positive_index;
        //echo $col_name;echo '<pre>';print_r($hourly_data[$negative_index]->r16);echo '</pre>';
        //$hour_sum = $hourly_data[0]->$col_name + $hourly_data[1]->$col_name + $hourly_data[2]->$col_name;
        $hour_sum = $positive_ar + $neutral_ar + $negative_ar;
        $positive_per = (!empty($hour_sum)) ? ceil(($positive_ar*100/$hour_sum)) : 0;
        $neutral_per = (!empty($hour_sum)) ? ceil($neutral_ar*100/$hour_sum) : 0;
        $negative_per = (!empty($hour_sum)) ? ceil($negative_ar*100/$hour_sum) : 0;
        
        
        $linechart_data['total_positive_feedback'] = $positive_per;
        $linechart_data['total_neutral_feedback'] = $neutral_per;
        $linechart_data['total_negetive_feedback'] = $negative_per;

        /////// Number of Feedback /////
        $sub_array=array();
        $sub_array[] =  array(
            "v" => "$t"
        );
        $sub_array[] =  array(
            "v" => $linechart_data['total_positive_feedback']
        );
        $sub_array[] =  array(
            "v" => $linechart_data['total_neutral_feedback']
        );
        $sub_array[] =  array(
            "v" => $linechart_data['total_negetive_feedback']
        );
        
        $rows[] =  array(
            "c" => $sub_array
        );

    }
    $table['rows'] = $rows;
    $data['jsonTable'] = json_encode($table);

    return $data;
}

function enc_text($text)
{
    $rand_1=Str::random(2);
    $rand_2=Str::random(4);
    $encode_text = base64_encode($rand_1.$text.$rand_2);
    return $encode_text;
}
function desc_text($text)
{
    $text = base64_decode($text);
    $text = substr($text, 2);
    $output_text = substr($text,0,-4);
    return $output_text;
}
?>