<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Database\Eloquent\SoftDeletes;


class Questions extends Model
{
    use HasFactory;
    use SoftDeletes;

    public $connection = 'mysql2';

   
    /**
     * The table associated with the model.
     *
     * @var string
    */ 
    protected $table = 'questions';

    /**
     * set primary key of table
     *
     * @var integer
     */
    //protected $primaryKey = 'id';

    /**
     * Indicates if the model should be timestamped.
     *
     * @var bool
     */
    public $timestamps = true;

    

    /**
     * fillable column name goes here
     *
     * @var array
     */
    protected $fillable = [
        'id',
        'servey_id',
        'question',
        'description',
        'positive_title',
        'negative_title',
        'question_type',
        'icon_type',
        'is_multi_seleted',
        'created_by',
        'updated_by',
        'deleted_by'
    ];

    public function options()
    {
        return $this->hasMany('\App\Models\QuestionOptions','question_id','id')->select(['id', 'option_id','options', 'question_id','response_tone']);
    }

    public function servey_feedback_questions()
    {
        return $this->hasMany('\App\Models\TemplateFeedbackQuestions','question_id','id')->select(['id', 'question_id','feedback_question_id','response_tone']);
        // return $this->hasMany(
        //     '\App\Models\TemplateFeedbackQuestions',
        //     '\App\Models\FeedbackQuestion',
        //     'feedback_question_id', // Foreign key on the environments table...
        //     'question_id', // Foreign key on the deployments table...
        //     'id', // Local key on the projects table...
        //     'id' // Local key on the environments table...
        // );
    }

    public function feedback_question(){
        return $this->hasMany('\App\Models\TemplateFeedbackQuestions');
    }

   
}
