@extends('layouts.admin.master')
@section('content')
<div class="container-xxl flex-grow-1 container-p-y">
    @include('common.messages')
    @include('common.errors')
    <!-- Hoverable Table rows -->
    <div class="card">
        <div class="row">
            <div class="col-md-9">                                    
                <h5 class="card-header">Listing</h5>            
            </div>
            <div class="col-md-3" style="margin-top:20px;">                                    
                <a href="{{ route('companies.create') }}" class="btn btn-success btn-large pull-right">Add Company</a>
            </div>
        </div>
        <div class="table-responsive text-nowrap">
            <table class="table table-hover">
                <thead>
                    <tr>
                    <th>Name</th>
                    <th>Email</th>
                    <th>Username</th>
                    <th>Contact</th>
                    <th>Actions</th>
                    </tr>
                </thead>
                <tbody class="table-border-bottom-0">
                    @if(!empty($companies))
                    @foreach($companies as $k=>$c)
                    <tr>
                        <td>{{ $c['name'] }}</td>
                        <td>{{ $c['email'] }}</td>
                        <td>{{ $c['username'] }}</td>
                        <td>{{ $c['contact_no'] }}</td>
                        <td>
                            <div class="dropdown">
                            <button type="button" class="btn p-0 dropdown-toggle hide-arrow" data-bs-toggle="dropdown">
                                <i class="bx bx-dots-vertical-rounded"></i>
                            </button>
                            <div class="dropdown-menu">
                                <a class="dropdown-item" href="{{ route('companies.edit',$c['id']) }}"
                                ><i class="bx bx-edit-alt me-1"></i> Edit</a
                                >
                                <a class="dropdown-item" href="{{ route('users.impersonate', $c['id']) }}"><i class="bx bx-log-in me-1"></i> Log in</a>
                                {!! Form::open(['url' => route('companies.destroy', $c['id']), 'method' => 'DELETE']) !!}
                                <button class="dropdown-item"
                                ><i class="bx bx-trash me-1"></i> Delete</button
                                >
                                {!! Form::close(); !!}
                                

                                <!-- <a href="{{ route('users.leave-impersonate') }}">Leave impersonation</a> -->
                            </div>
                            </div>
                        </td>
                    </tr>
                    @endforeach
                    @endif
                </tbody>
            </table>
        </div>
        <div class="pull-right">
            {{ $companies->links() }}
        </div>
    </div>
    <!--/ Hoverable Table rows -->
</div>
@endsection

