@extends('layouts.admin.master')
@section('content')
<div class="container-xxl flex-grow-1 container-p-y">
    <!-- Hoverable Table rows -->
    <div class="card">
        <div class="row">
            <div class="col-xl">
                <div class="card mb-8">
                <div class="card-header d-flex justify-content-between align-items-center">
                    <h5 class="mb-0">Edit Monitor</h5>
                    <small class="text-muted float-end"></small>
                </div>
                <div class="row px-4">
                    <div class="col-md-4">
                        {!! QrCode::size(100)->generate(url('give-rating/'.$encode_monitor_id)) !!}
                    </div>
                    <div class="col-md-8 text-end">
                        <button class="btn btn-info" onclick="window.location.href='{{ route('monitor.reset_settings',$monitor->id) }}'"
                            > Get Settings</button
                            >
                        <a href="{{ route('monitor.duplicate',$monitor->id) }}" class="d-inline-block btn btn-success">Duplicate monitor</a>
                        {!! Form::open(['url' => route('monitors.destroy', $monitor->id), 'method' => 'DELETE','class'=>'d-inline-block']) !!}
                            <button class="btn btn-danger"
                            > Delete</button
                            >
                        {!! Form::close(); !!}
                    </div>
                </div>
                <div class="card-body">
                    {!! Form::open([
                            'route' => ['monitors.update',$monitor->id],
                            'method' => 'PUT',
                            'name' => 'edit_monitor_form',
                            'id' => 'edit_monitor_form',
                            'autocomplete' => 'off',
                            'enctype' => 'multipart/form-data'
                        ])
                    !!}

                    @csrf
                    
                        @include('admin.monitors.form')
                        <button type="submit" class="btn btn-primary">Save</button>
                        <a href="{{ route('monitors.index') }}" class="btn btn-danger">Cancel</a>
                    </form>
                </div>

                <!-- select 
	 id,FK_monitor_id, bathroom_type,currentdate,currenttime from monitor_rating
WHERE FK_monitor_id=210 and currentdate='2022-07-18' and bathroom_type=2  and DATE_FORMAT(`currenttime`, '%H:%i') = '00:35' and id NOT IN 
  (SELECT 
    * 
  FROM
    (SELECT 
      MAX(id) 
    FROM
      `monitor_rating` 
      where FK_monitor_id=210 and currentdate='2022-07-18' and bathroom_type=2  and DATE_FORMAT(`currenttime`, '%H:%i') = '00:35'
    GROUP BY FK_monitor_id, bathroom_type,currentdate) tbl) -->
                </div>
            </div>
        </div>
    </div>
</div>
@endsection