<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});


Route::post('/login', [App\Http\Controllers\api\AuthController::class, 'login']);
Route::post("monitor/login",[App\Http\Controllers\api\MonitorLogin::class,'login']);
Route::post("monitor/user_login",[App\Http\Controllers\api\MonitorLogin::class,'UserLogin'])->name('monitor.user_login');
Route::post("monitor/logout",[App\Http\Controllers\api\MonitorLogin::class,'logout'])->name('monitor.logout');
Route::get("sync/db",[App\Http\Controllers\api\SyncDB::class,'sync_data'])->name('sync.db');
Route::post("test/user",[App\Http\Controllers\api\Test::class,'user']);


Route::middleware('api_auth')->group(function () {
    Route::get("monitor/get_data",[App\Http\Controllers\api\MonitorApi::class,'getData']);
    Route::post("monitor/validate_token",[App\Http\Controllers\api\MonitorApi::class,'validateToken']);
    Route::post("monitor/get_settings",[App\Http\Controllers\api\MonitorApi::class,'GetSettings']);
    Route::post("monitor/save_feedback",[App\Http\Controllers\api\MonitorApi::class,'SaveFeedback']);
    Route::post("monitor/reset_settings_notification",[App\Http\Controllers\api\MonitorApi::class,'ResetSettingsNotification']);
});

Route::middleware('hlite_auth')->group(function () {
    Route::post("hygiene/save_feedback",[App\Http\Controllers\api\HygieneMonitorRatingApi::class,'SaveFeedback']);
    Route::post("hygiene/save_footfall",[App\Http\Controllers\api\HygieneMonitorFootfallApi::class,'SaveFootfall']);
    Route::post("hygiene/save_cleaning_activity",[App\Http\Controllers\api\HygieneMonitorCleaningActivityApi::class,'SaveCleaningActivity']);
});
