<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\TestController;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::get('/', function () {
    return redirect('/login');
});

// Route::middleware(['auth:sanctum', 'verified'])->get('/dashboard', function () {
//     //return view('dashboard');
//     //Route::get('/dashboard', [App\Http\Controllers\DashboardController::class, 'index']);
//     Route::get('/dashboard','App\Http\Controllers\DashboardController@index')->name('dashboard');
// });

Route::middleware(['auth:sanctum', 'verified'])->group(function () {
    //Route::get('/dashboard','App\Http\Controllers\DashboardController@index')->name('dashboard');
});

Route::middleware('dynamic:dashboard')->group(function () {
    //return phpinfo();
    Route::get('dashboard','App\Http\Controllers\DashboardController@index')->name('dashboard');
});

Route::get('/{user}/impersonate', 'App\Http\Controllers\UsersController@impersonate')->name('users.impersonate');
Route::get('/leave-impersonate', 'App\Http\Controllers\UsersController@leaveImpersonate')->name('users.leave-impersonate');

Route::prefix('admin')->group(function () {

    // Route::middleware('dynamic:dashboard')->group(function () {
    //     Route::get('dashboard','App\Http\Controllers\DashboardController@index')->name('dashboard');
    // });

    Route::get('/demo', [App\Http\Controllers\DemoController::class, 'index']);
    Route::get('/post',[App\Http\Controllers\PostController::class, 'index']);
    Route::post('/post-sortable',[App\Http\Controllers\PostController::class, 'update']);

    Route::middleware('dynamic')->group(function () {
        Route::post('ajax/get-monitors-and-questions-by-site', 'App\Http\Controllers\AjaxController@get_monitors_and_questions_by_site')->name('ajax.get-monitors-and-questions-by-site');
        Route::post('ajax/get-questions-by-monitor', 'App\Http\Controllers\AjaxController@get_questions_by_monitor')->name('ajax.get-questions-by-monitor');
        Route::post('ajax/get-customize-date', 'App\Http\Controllers\AjaxController@get_customize_date')->name('ajax.get-customize-date');
    });

    Route::middleware('dynamic:ratings')->group(function () {
        Route::get('rating/listing','App\Http\Controllers\RatingController@listing')->name('rating.listing');
        Route::get('rating/show/{id}','App\Http\Controllers\RatingController@show')->name('rating.show');
        Route::get('rating/question-report','App\Http\Controllers\RatingController@question_report')->name('rating.question_report');
        Route::get('rating/export-ratings/{monitor_id}/{from_date}/{to_date}/','App\Http\Controllers\RatingController@export_ratings')->name('rating.export-ratings');
    });

    Route::resource('companies',App\Http\Controllers\CompanyController::class);

    Route::middleware('dynamic:sites')->group(function () {
        Route::resource('sites',App\Http\Controllers\SiteController::class);
        Route::resource('site_users',App\Http\Controllers\SiteUsersController::class);
    });
    Route::middleware('dynamic:servey')->group(function () {
        Route::resource('servey',App\Http\Controllers\ServeyController::class);
    });
    Route::middleware('dynamic:questions')->group(function () {
        Route::get('servey/template/{id}/', 'App\Http\Controllers\ServeyTemplateController@view')->name('servey.template');
        Route::get('servey/template/details/{id}/', 'App\Http\Controllers\ServeyTemplateController@details')->name('servey.template.details');
        Route::get('servey/template/create/{id}/', 'App\Http\Controllers\ServeyTemplateController@create')->name('servey.template.create');
        Route::post('servey/template/save/{question_type}/{id}/', 'App\Http\Controllers\ServeyTemplateController@save')->name('servey.template.save');
        Route::post('servey/template/update/{question_type}/{id}/{servey_id}/', 'App\Http\Controllers\ServeyTemplateController@update')->name('servey.template.update');
        Route::post('servey/template/update_order/{servey_id}', 'App\Http\Controllers\ServeyTemplateController@update_order')->name('servey.template.update_order');
        Route::get('servey/template/save_free_text/{question_type}/{id}/', 'App\Http\Controllers\ServeyTemplateController@save_free_text')->name('servey.template.save_free_text');
        Route::get('servey/template/add_question/{question_type}/{servey_id}', 'App\Http\Controllers\ServeyTemplateController@add_question')->name('servey.template.add_question');
        Route::delete('servey/template/delete/{id}', 'App\Http\Controllers\ServeyTemplateController@delete_question')->name('servey.template.delete_question');
        Route::get('servey/dupliacte/{id}', [App\Http\Controllers\ServeyTemplateController::class, 'duplicate'])->name('servey.duplicate');
        Route::get('servey/template/delete_option/{id}', 'App\Http\Controllers\ServeyTemplateController@delete_option')->name('servey.template.delete_option');
    });
    Route::middleware('dynamic:feedback_questions')->group(function () {
        Route::resource('feedback_questions',App\Http\Controllers\FeedbackQuestionController::class);
    });
    Route::middleware('dynamic:monitors')->group(function () {
        Route::resource('monitors',App\Http\Controllers\MonitorController::class);
        //Route::get('/monitors/listing',App\Http\Controllers\MonitorController::class,'listing');
        Route::get('monitors/listing', [App\Http\Controllers\MonitorController::class, 'listing']);
        Route::get('monitors/dupliacte/{id}', [App\Http\Controllers\MonitorController::class, 'duplicate'])->name('monitor.duplicate');
        Route::get('monitors/reset_settings/{id}', [App\Http\Controllers\MonitorController::class, 'reset_settings'])->name('monitor.reset_settings');
    });
    Route::get ('access_company/{id}',[App\Http\Controllers\AccessCompanyController::class,'view']);
});

////// web routes ////
Route::middleware('web_db')->group(function () {
    Route::get('feedback/give-rating/{id}','App\Http\Controllers\web\FeedbackController@give_rating')->name('feedback.give-rating');
    Route::post('feedback/save/{id}','App\Http\Controllers\web\FeedbackController@save')->name('feedback.save');
    Route::post('feedback/insert/{id}','App\Http\Controllers\web\FeedbackController@insert')->name('feedback.insert');
    Route::get('feedback/thank-you/{id}',[App\Http\Controllers\web\FeedbackController::class,'thanks'])->name('thank-you');
});

Route::middleware('web_enc_db')->group(function () {
    Route::get('give-rating/{rating}','App\Http\Controllers\web\FeedbackController@giveRating')->name('give-rating');
});

Route::prefix('api_ui')->group(function () {
    Route::get("index",[App\Http\Controllers\apiui\FormController::class,'index']);
});


Route::get ('logout',[App\Http\Controllers\LogoutController::class,'logout']);

Route::get('hygiene/feedbacks', [App\Http\Controllers\HygineWebController::class, 'feedbacks'])->name('hygiene.feedbacks');
Route::get('hygiene/footfalls', [App\Http\Controllers\HygineWebController::class, 'footfalls'])->name('hygiene.footfalls');
Route::get('hygiene/cleaning-activity', [App\Http\Controllers\HygineWebController::class, 'cleaning_activity'])->name('hygiene.cleaning_activity');

//Route::resource('companies',App\Http\Controllers\CompanyController::class);

// Route::group(['prefix' => 'admin', 'namespace' => '', 'middleware' => ''], function() {
//     Route::get('photos',[App\Http\Controllers\PhotoController::class, 'index']);
// });