<?php $__env->startSection('content'); ?>
<div class="container-xxl flex-grow-1 container-p-y">
    <?php echo $__env->make('common.messages', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
    <?php echo $__env->make('common.errors', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
    <!-- Hoverable Table rows -->
    <div class="card">
        <div class="row">
            <div class="col-md-9">                                    
                <h5 class="card-header">Listing</h5>            
            </div>
        </div>
        <div class="container">
            <?php echo Form::open([
                    'route' => ['rating.listing'],
                    'method' => 'GET',
                    'name' => 'add_feedback_questions_form',
                    'id' => 'add_feedback_questions_form',
                    'autocomplete' => 'off',
                    'enctype' => 'multipart/form-data'
                ]); ?>

            <div class="row">
                <div class="mb-3 col-md-3">
                    <div class="col-md-10">
                        <label>From Date</label>
                        <input class="form-control" name="from_date" type="date" value="<?php echo e($params['from_date'] ?? ''); ?>" id="dash_from" placeholder="From Date">
                    </div>
                </div>
                <div class="mb-3 col-md-3">
                    <div class="col-md-10">
                        <label>To Date</label>
                        <input class="form-control" name="to_date" type="date" value="<?php echo e($params['to_date'] ?? ''); ?>" id="dash_to" placeholder="To Date">
                    </div>
                </div>

                <div class="mb-3 col-md-3">
                    <div class="col-md-10">
                    <label>Monitor</label>
                    <?php echo Form::select('monitor_id', [0 => 'All'] + $monitors, old('monitor_id', (!empty($params['monitor_id']) && $params['monitor_id']) ? $params['monitor_id'] : ''), ['class' => 'form-control', 'id' => 'monitor_id']); ?>

                    </div>
                </div>

                <div class="mb-3 col-md-1">
                    <button type="submit" class="btn btn-small btn-primary">Submit</button>
                </div>
            </div>
            <?php echo Form::close(); ?>

        
            <div class="table-responsive text-nowrap">
                <table class="table table-hover">
                <thead>
                    <tr>
                    <th>Monitor</th>
                    <th>Total Positive</th>
                    <th>Total Negative</th>
                    <th>Total Neutral</th>
                    <th>Date</th>
                    <th>Actions</th>
                    </tr>
                </thead>
                <tbody class="table-border-bottom-0">
                    <?php if(!empty($ratings)): ?>
                    <?php $__currentLoopData = $ratings; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $k=>$c): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                    <?php //echo '<pre>';print_r($c); exit;?>
                    <tr>
                        <td>
                            <?php 
                                $monitor = \App\Models\Monitor::where('id',$c['monitor_id'])->get()->first();
                                echo $monitor->inbuild_location.' '.$monitor->build_location;
                            ?>
                        </td>
                        <td><?php echo e($c['positive']); ?></td>
                        <td><?php echo e($c['negative']); ?></td>
                        <td><?php echo e($c['nuetral']); ?></td>
                        <td>
                            <?php 
                            $date = new DateTime($c['created_at'], new DateTimeZone('UTC'));
                            $date->setTimezone(new DateTimeZone('Europe/London'));
                            echo $date->format('m/d/Y H:i:s');
                            ?>
                        <td>
                        <a class="btn btn-small btn-warning" href="<?php echo e(route('rating.show',$c['id'])); ?>"
                        > Details</a>
                        </td>
                    </tr>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    <?php endif; ?>
                </tbody>
                </table>
            </div>
            <div class="pull-right">
                <?php echo e($ratings->links()); ?>

            </div>
        </div>
    </div>
    <!--/ Hoverable Table rows -->
</div>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('layouts.admin.master', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /var/www/html/resources/views/admin/ratings/index.blade.php ENDPATH**/ ?>